<?php
namespace Smilepay\Smilepayatm\Observer;

use Magento\Framework\Event\ObserverInterface;
    use Magento\Framework\DataObject;
use Magento\Payment\Model\InfoInterface;
use Magento\Payment\Model\MethodInterface;
use Magento\Payment\Observer\AbstractDataAssignObserver;
use Magento\Sales\Model\Order\Invoice;
use Magento\Sales\Model\Order\Payment;
use Magento\Quote\Api\Data\PaymentMethodInterface;


class PlaceOrderSuccess  implements ObserverInterface
{
    protected $_storeManager;
    protected $_orderFactory;
    protected $_smilepayatm_session;
    protected $_smilepayatm_paymentmethod;
    protected $_smilepayatm_helper_data;
    protected $_context;
    public function __construct(
        \Magento\Framework\App\Action\Context $context,
        \Magento\Sales\Model\Order $orderFactory,
        \Smilepay\Smilepayatm\Model\Session $smilepayatm_session,
        \Smilepay\Smilepayatm\Model\Paymentmethod $smilepayatm_paymentmethod,
        \Magento\Store\Model\StoreManagerInterface $storeManager,
        \Smilepay\Smilepayatm\Helper\Data   $smilepayatm_helper_data)
    {
        $this->_storeManager = $storeManager;
        $this->_orderFactory = $orderFactory;
        $this->_smilepayatm_session = $smilepayatm_session;
        $this->_smilepayatm_paymentmethod = $smilepayatm_paymentmethod;
        $this->_smilepayatm_helper_data=$smilepayatm_helper_data;
        $this->_context =$context;
    }

  //generate order info to checkout success
  public function execute(\Magento\Framework\Event\Observer $observer)
  {
      $event = $observer->getEvent();
    
      $order_id = $event->getOrderIds()[0];

      if(!isset($order_id) || empty($order_id))
          return;
      $order =$this->_orderFactory;
      $order->load($order_id);

      $paymentmethod = $order->getPayment()->getMethod();

      if( trim($paymentmethod) == 'smilepayatm')
      {
          $controlleraction = $this->_context->getView();


          /*$block = $controlleraction->getLayout()->createBlock('Magento\Framework\View\Element\Template','smilepayatm_message',
                                                                                                                        array('data'=> 
                                                                                                                                array('template' => 'Smilepay_Smilepayatm::placeorder/success.phtml')
                                                                                                                         ));*/

          //$block =$controlleraction->getLayout()->addBlock('Magento\Framework\View\Element\Template','smilepayatm_message','order.success.additional.info');  
          $block =$controlleraction->getLayout()->addBlock('Magento\Framework\View\Element\Template','smilepayatm_message','content');  
          $block->setTemplate('Smilepay_Smilepayatm::placeorder/success.phtml');
          $session= $this->_smilepayatm_session;
          $smilepayatm_result=$session->getSmilepayatmResult();
          $smilepayatm_model= $this->_smilepayatm_paymentmethod;


       

          $block->assign(
                        array(
                            'smilepay_atm_title' =>   $smilepayatm_model->getTitle(),
                            'smilepay_atm_status' =>  $smilepayatm_result['Status'],
                            'smilepay_atm_bank_no' =>$smilepayatm_result['AtmBankNo'],
                            'smilepay_atm_no' => $smilepayatm_result['AtmNo'],
                            'smilepay_atm_amount' => $smilepayatm_result['Amount'],
                            'smilepay_atm_dateline' => $smilepayatm_result['PayEndDate'],
                             )
                    );
          $session->clearStorage();
     
          $controlleraction->getLayout()->reorderChild("content",'smilepayatm_message','checkout.success',false);

      
      //    $controlleraction->getLayout()->getBlock('checkout.success')->insert($block,'',false);
     
      }
    
  }
}


?>