<?php
    
namespace Smilepay\Smilepayc2cp\Controller;

abstract class Smilepayc2cpController extends \Magento\Framework\App\Action\Action
{
    protected $smseResult;
    protected $smseurl='https://ssl.smse.com.tw/ezpos/mtmk_utf.asp';
    protected $smseurl_back ='https://ssl.smse.com.tw/api/SPPayment.asp';
    

    protected $_checkoutSession;
    protected $_orderFactory;
    protected $_smilepayc2cp_session;
    protected $_smilepayc2cp_paymentmethod;
    protected $_smilepayc2cp_shippingmethod;
    protected $_smilepayc2cp_helper_data;
    protected $_resultPageFactory;
    protected $_urlInterface;
    protected $_objectManager;
    
    public function __construct(
        \Magento\Framework\App\Action\Context $context,
        \Magento\Framework\View\Result\PageFactory $resultPageFactory,
        \Magento\Checkout\Model\Session $checkoutSession,
        \Magento\Sales\Model\Order $orderFactory,
        \Smilepay\Smilepayc2cp\Model\Session $smilepayc2cp_session,
        \Smilepay\Smilepayc2cp\Model\Paymentmethod $smilepayc2cp_paymentmethod,
        \Smilepay\Smilepayc2cp\Model\Shippingmethod $smilepayc2cp_shippingmethod,
        \Smilepay\Smilepayc2cp\Helper\Data   $smilepayc2cp_helper_data
     
      
       
    ) {
        $this->_checkoutSession = $checkoutSession;
        $this->_orderFactory = $orderFactory;
        $this->_smilepayc2cp_session = $smilepayc2cp_session;
        $this->_smilepayc2cp_paymentmethod = $smilepayc2cp_paymentmethod;
        $this->_smilepayc2cp_shippingmethod = $smilepayc2cp_shippingmethod;
        $this->_smilepayc2cp_helper_data=$smilepayc2cp_helper_data;
        $this->_resultPageFactory = $resultPageFactory;
        //$this->_urlInterface = $urlInterface;
        $this->_urlInterface =$context->getUrl();
        $this->_objectManager = $context->getObjectManager();
        //$this->_objectManager = $objectManager;
       
        parent::__construct($context);
    }
    
      
    //Emap return
   /* public function mapreturnAction()
    {
        
        $Classif = $_REQUEST['Classif'];
        $Data_id =  $_REQUEST['Data_id'];
        //$Process_datetime = $_REQUEST['Process_date'] ." ". iconv("big5","UTF-8", $_REQUEST['Process_time']);     
        $Amount =   $_REQUEST['Amount'];
        $Smseid = $_REQUEST['Smseid'];
       // $Mid_smilepay = $_REQUEST['Mid_smilepay'];
      //  $Errdesc = $_REQUEST['Errdesc'];
        $Storeid = $_REQUEST['Storeid'];
        $Storename =  $_REQUEST['Storename'];
        $Storeaddress =  $_REQUEST['Storeaddress'];
        $Mobile_number =  $_REQUEST['Mobile_number'];
        $Pur_name =  $_REQUEST['Pur_name'];
        $Classif_sub = $_REQUEST['Classif_sub'];
        $Status =  $_REQUEST['Status'];

        if(empty($Data_id))
        {
           
            echo __('smilepay_c2cp_order_id_error');
            exit;
        }
        $order =  $this->_orderFactory;
        $order->loadByIncrementId($Data_id);

        $session= $this->getSession();

        if((intval(round($order->getBaseGrandTotal()))==$Amount || intval(round($order->getGrandTotal()))==$Amount) && $Classif == 'T' && $Status==1 )
        {
            $paymentmethod=$this->_smilepayc2cp_paymentmethod;

            $admincomment=sprintf(__('smilepay_c2cp_placeorder_comment_admin_success'),$Smseid,$Storeid,$Storename,$Storeaddress);
            $customercomment=sprintf(__('smilepay_c2cp_placeorder_comment_customer_success'),$Storeid,$Storename,$Storeaddress);
            $c2curl=sprintf('http://ssl.smse.com.tw/api/C2CPayment.asp?smseid=%s&dcvc=%s&types=web&Verify_key=%s', $Smseid,trim( $paymentmethod->getDcvc()),trim($paymentmethod->getVkey()));
            $order->addStatusHistoryComment( $admincomment,false);
            //$order->setState(Mage_Sales_Model_Order::STATE_PROCESSING,true, $admincomment);
            //$order->setState($order->getState(),true, $customercomment,true);
            $history=$order->addStatusHistoryComment($customercomment,false);
            $history->setIsCustomerNotified(true);
            $history->setIsVisibleOnFront(1);
            $order->save();
            $order->sendOrderUpdateEmail(true, $customercomment);

            $result = array(
                        'Status' => $Status,
                        'Storename'=>$Storename,
                        'Storeaddress'=>$Storeaddress,
                        'Storeid'=>$Storeid,
                        'Amount'=>$Amount,
                        'Pur_name'=>$Pur_name,
                        'Data_id'=>$Data_id,
                        'Mobile_number'=>$Mobile_number
                        );

            $session->setSmilepayc2cpResult($result);


           // $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
            $resource = $this->_objectManager->get('Magento\Framework\App\ResourceConnection');
            

            $db_write= $resource->getConnection();
            
            $db_write->insert($resource->getTableName('smilepayc2cp_record'),
                                     array("order_increment_id" =>  $Data_id,
                                           "smse_id" => $Smseid,
                                           "record_url"=> $c2curl,
                                           )
                            );
           $db_write->closeConnection();           
           // echo '<Roturlstatus>magento1.8.1_Ok</Roturlstatus>';
            $this->_redirect('checkout/onepage/success');
        }
        else
        {
               
            $admincomment=sprintf(__('smilepay_c2cp_placeorder_comment_admin_fail'));
            $customercomment=sprintf(__('smilepay_c2cp_placeorder_comment_customer_fail'));
           // $order->setState(\Magento\Sales\Model\Order::STATE_CANCELED,true, $admincomment);
            //$order->setState($order->getState(),true, $customercomment,true);
            $order->addStatusHistoryComment($admincomment,\Magento\Sales\Model\Order::STATE_CANCELED);
            $history=$order->addStatusHistoryComment($customercomment,false);
            $history->setIsCustomerNotified(true);
            $history->setIsVisibleOnFront(1);
            $order->save();


            $emailSender = $this->_objectManager->create('\Magento\Sales\Model\Order\Email\Sender\OrderSender');
            $emailCommentSender = $this->_objectManager->create('\Magento\Sales\Model\Order\Email\Sender\OrderCommentSender');

            $emailCommentSender->send($order,true, $customercomment);

            //$result = array(
             //           'smilepayc2cp_error_message'=>$Errdesc
              //          );
            //$session->setSmilepayc2cpResult($result);
            

           // $checkoutsession=Mage::getSingleton('checkout/session');

            //$checkoutsession->addError($customercomment);
            $this->_redirect('checkout/onepage/failure');
        }

    }
    */

    //place order to SMSe
    protected function connectionSmse()
    {
        $session = $this->_checkoutSession;
        $quote = $session->getQuote();
        $order = $this->_orderFactory;
        $order_id = $session->getLastOrderId();
        //$url='https://ssl.smse.com.tw/api/SPPayment.asp';
        $order->load($order_id);
        if($order->getId()==0)
        {
           $this->_redirect('checkout/cart');
           return FALSE;
           // throw new \Exception("Error not found Order");
        }
        $customer_name= $order->getBillingAddress()->getLastname() . $order->getBillingAddress()->getFirstname() ;
        $customer_email=$order->getCustomerEmail();
        $phone = $order->getBillingAddress()->getTelephone();
        $billAddress=$order->getBillingAddress();
        $address=  $billAddress->getData('region') . " " . $billAddress->getData('city') ." " .  $billAddress->getData('street');
        $paymentmethod=$this->_smilepayc2cp_paymentmethod;
        $shippingmethod = $this->_smilepayc2cp_shippingmethod;

        if($shippingmethod->getCurrencyLimit()==true)
        {
            $total = $order->getGrandTotal();
        }
        else
        {
            //find TWD selected?
            if($this->_smilepayc2cp_helper_data->isCurrencyTWDselected())
                $total = $order->getGrandTotal();
            else
                $total = $order->getBaseGrandTotal();
        }
          
        $c2cstoredata = $shippingmethod->getC2CpStoreData();
        $paysubzg = $shippingmethod->getPay_subzg($c2cstoredata['CVSType']);
        $postdata = array(
                        'Dcvc' =>trim( $paymentmethod->getDcvc()),
                        'Rvg2c' => trim($paymentmethod->getRvg2c()),
                        'Verify_key' =>trim($paymentmethod->getVkey()),
                        'Pay_gdry' =>'TW',
                        'Od_sob' => $session->getLastRealOrderId(),
                        'Pay_zg' => 51,
                        'Pay_subzg'=> $paysubzg,
                        'Data_id' => $session->getLastRealOrderId(),
                        'Amount' => intval(round($total)),
                        'Pur_name' => $customer_name,
                        'Tel_number' =>  $phone,
                        'Mobile_number' => $phone,
                       // 'Address' => $address,
                        'Email' => $customer_email,
                        'Roturl' => $this->_urlInterface->getUrl("smilepayc2cp/pay/paid") ,
                     //   'MapRoturl' =>Mage::getUrl("smilepayc2cp/smilepayc2cp/mapreturn") ,
                        'Roturl_status'=>'magento1.8.1_Ok',
                        'Logistics_store'=> $c2cstoredata['Storeid'] ."/" .$c2cstoredata['Storename'] . "/" .$c2cstoredata['Storeaddress'],
                    );

        /*//create postdata form
        $block = $this->getLayout()->createBlock('Mage_Core_Block_Template','smileapayc2cp/smilepayc2cp_sendform');

        $block->assign(  
                    array(
                        'smilepay_c2cp_postdata'=>$postdata,
                        'smilepay_c2cp_action_url'=> $this->smseurl,
                        )
                    );
        //form
        $block->setTemplate('smilepayc2cp/placeorder/send.phtml');
        //output
        echo $block->toHtml();
   */
  
          
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $this->smseurl_back);
        curl_setopt($ch, CURLOPT_VERBOSE, 1);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
        curl_setopt($ch,CURLOPT_POSTFIELDS,http_build_query( $postdata));
       
        $resultxml=curl_exec($ch); 
        curl_close($ch);

        $smilepay_session = $this->getSession();

        if(!is_null( $resultxml) && !empty($resultxml) )
        {
            $xml = simplexml_load_string($resultxml);
            if (isset( $xml)) 
            {
                (strlen(trim($xml->PayEndDate)) >8 ) ? $xmlPayEndDate=$xml->PayEndDate : $xmlPayEndDate="" ;                  
                $result= array(
                    'Amount' => strval($xml->Amount),
                    'Data_id'=> strval($xml->Data_id),
                    'Status'=> strval($xml->Status),
                    'Desc' => strval($xml->Desc),
                    'SmilePayNO'=> strval($xml->SmilePayNO),
                    'Storeid'=> $c2cstoredata['Storeid'],
                    'Storename' => $c2cstoredata['Storename'],
                    'Storeaddress' => $c2cstoredata['Storeaddress'],
                    'Pur_name' => $customer_name,
                    'Mobile_number' => $phone,
                 );   
               // return $result;
              
            }
            else
            {
                $result = array(
                        'Status' => '-1000',
                        'Desc'=>'取號失敗',    
                        'Data_id'=>$session->getLastRealOrderId(),
                    );   
    
            }
        }
        else
        {
            $result = array(
                        'Status' => '-1000',
                        'Desc'=>'取號失敗',    
                        'Data_id'=>$session->getLastRealOrderId(),
                    );   
  
        }
        $smilepay_session->setSmilepayc2cpResult($result);
      
        if($result['Status']==1) // success
        {
             
            $Smseid=$result['SmilePayNO'];
            $Storeid=$result['Storeid'];
            $Storename=$result['Storename'];
            $Storeaddress=$result['Storeaddress'];
            $Data_id=$result['Data_id'];
            $paymentmethod=$this->_smilepayc2cp_paymentmethod;

            $admincomment=sprintf(__('smilepay_c2cp_placeorder_comment_admin_success'),$Smseid,$result['Pur_name'],$result['Mobile_number'],$Storeid,$Storename,$Storeaddress);
            $customercomment=sprintf(__('smilepay_c2cp_placeorder_comment_customer_success'), $result['Pur_name'],$result['Mobile_number'],$Storeid,$Storename,$Storeaddress);
            $c2curl=sprintf('http://ssl.smse.com.tw/api/C2CPayment.asp?smseid=%s&dcvc=%s&types=web&Verify_key=%s&Pay_subzg=%s', $Smseid,trim( $paymentmethod->getDcvc()),trim($paymentmethod->getVkey()),$paysubzg);
            $order->addStatusHistoryComment( $admincomment,false);
            //$order->setState(Mage_Sales_Model_Order::STATE_PROCESSING,true, $admincomment);
            //$order->setState($order->getState(),true, $customercomment,true);
            $history=$order->addStatusHistoryComment($customercomment,false);
            $history->setIsCustomerNotified(true);
            $history->setIsVisibleOnFront(1);
            $order->save();

            $emailSender = $this->_objectManager->create('\Magento\Sales\Model\Order\Email\Sender\OrderSender');
            if( $order->getCanSendNewEmailFlag())
            {
                $emailSender->send($order);
            }

            //$emailSender = $this->_objectManager->create('\Magento\Sales\Model\Order\Email\Sender\OrderSender');
            $emailCommentSender = $this->_objectManager->create('\Magento\Sales\Model\Order\Email\Sender\OrderCommentSender');
            $emailCommentSender->send($order,true, $customercomment);
            //$order->sendOrderUpdateEmail(true, $customercomment);

           /* $result = array(
                        'Status' => $Status,
                        'Storename'=>$Storename,
                        'Storeaddress'=>$Storeaddress,
                        'Storeid'=>$Storeid,
                        'Amount'=>$Amount,
                        'Pur_name'=>$Pur_name,
                        'Data_id'=>$Data_id,
                        'Mobile_number'=>$Mobile_number
                        );

            $session->setSmilepayc2cpResult($result);
            */
            $resource = $this->_objectManager->get('Magento\Framework\App\ResourceConnection');
            

            $db_write= $resource->getConnection();
            
            $db_write->insert($resource->getTableName('smilepayc2cp_record'),
                                     array("order_increment_id" =>  $Data_id,
                                           "smse_id" => $Smseid,
                                           "record_url"=> $c2curl,
                                           )
                            );
            $db_write->closeConnection();           
            $this->_redirect('checkout/onepage/success');
        }
        else
        {
            

            $admincomment=sprintf(__('smilepay_c2cp_placeorder_comment_admin_fail'),$result['Status'],$result['Desc']);
            $customercomment=sprintf(__('smilepay_c2cp_placeorder_comment_customer_fail'));
            //$order->setState(\Magento\Sales\Model\Order::STATE_CANCELED,true, $admincomment);
            $order->addStatusHistoryComment($admincomment,\Magento\Sales\Model\Order::STATE_CANCELED);
            //$order->setState($order->getState(),true, $customercomment,true);
            $history=$order->addStatusHistoryComment($customercomment,false);
            $history->setIsCustomerNotified(true);
            $history->setIsVisibleOnFront(1);
            $order->save();
            //$order->sendOrderUpdateEmail(true, $customercomment);

            $emailSender = $this->_objectManager->create('\Magento\Sales\Model\Order\Email\Sender\OrderSender');
            if( $order->getCanSendNewEmailFlag())
            {
                $emailSender->send($order);
            }

            $emailCommentSender = $this->_objectManager->create('\Magento\Sales\Model\Order\Email\Sender\OrderCommentSender');
            $emailCommentSender->send($order,true, $customercomment);
            /*$result = array(
                        'smilepayc2cp_error_message'=>$Errdesc
                        );
            $session->setSmilepayc2cpResult($result);
            */

           // $checkoutsession=Mage::getSingleton('checkout/session');

            //$checkoutsession->addError($customercomment);
            $this->_redirect('checkout/onepage/failure');
        }
           

    }
    
    function getSession()
    {
        return $this->_smilepayc2cp_session;
    }
    //mid check function
    protected function midfun($Mid_value,$Amount,$Smseid,$Mid_smilepay)
    {   
        $Amount = str_pad($Amount,8,'0',STR_PAD_LEFT);                   
        $Smseid= preg_replace('/[\D]/i','9',substr($Smseid,-4));      
        $dtotal=$Mid_value.$Amount.$Smseid;                              
      
        $i = 1;
        $sum = strlen($dtotal);
        $etemp=0;      
        while ($i <= $sum)
        {
            $ep = substr($dtotal,$i,1);
            $etemp = $etemp + $ep;                
            $i=$i+2;
        }                
      
        $i = 0;  
        $otemp=0;          
        while ($i <= $sum)
        {                                              
            $op = substr($dtotal,$i,1);
            $otemp = $otemp + $op;
            $i=$i+2;
        }
        $mid=($etemp*3)+($otemp*9);    
      
        if($Mid_smilepay == $mid){
            return true;
        }else{
            return false;
        }            
    }  
     	
  	

}

?>