<?php
namespace  Smilepay\Smilepayc2cp\Model;


use Magento\Quote\Api\Data\CartInterface;

use Magento\Framework\DataObject;
use Magento\Payment\Model\InfoInterface;
use Magento\Payment\Model\MethodInterface;
use Magento\Payment\Observer\AbstractDataAssignObserver;
use Magento\Sales\Model\Order\Invoice;
use Magento\Sales\Model\Order\Payment;
use Magento\Quote\Api\Data\PaymentMethodInterface;

class Paymentmethod extends \Magento\Payment\Model\Method\AbstractMethod
{
    const PAYMENT_METHOD_SMILEPAYC2CP_CODE = 'smilepayc2cp';
    protected $_code  = self::PAYMENT_METHOD_SMILEPAYC2CP_CODE;
    //protected $_isOffline = true;

    /**
     * Cash On Delivery payment block paths
     *
     * @var string
     */
     
    protected $_formBlockType = 'smilepayc2cp/form_smilepayc2cpcheckout';
    //protected $_infoBlockType = 'payment/info';


    protected $_smilepayc2c_helper_data;
    protected $_storeManager;
    protected $_urlInterface;
    public function __construct(
        \Magento\Framework\Model\Context $context,
        \Magento\Framework\Registry $registry,
        \Magento\Framework\Api\ExtensionAttributesFactory $extensionFactory,
        \Magento\Framework\Api\AttributeValueFactory $customAttributeFactory,
        \Magento\Payment\Helper\Data $paymentData,
        \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig,
        \Magento\Payment\Model\Method\Logger $logger,
        \Smilepay\Smilepayc2cp\Helper\Data   $smilepayc2c_helper_data,
        \Magento\Store\Model\StoreManagerInterface $storeManager,
        \Magento\Framework\UrlInterface $urlInterface,
        \Magento\Framework\Model\ResourceModel\AbstractResource $resource = null,
        \Magento\Framework\Data\Collection\AbstractDb $resourceCollection = null,
        array $data = []
    ) {

        parent::__construct(
            $context,
            $registry,
            $extensionFactory,
            $customAttributeFactory,
            $paymentData,
            $scopeConfig,
            $logger,
            $resource,
            $resourceCollection,
            $data
        );
        $this->_smilepayc2c_helper_data =$smilepayc2c_helper_data;
        $this->_storeManager=$storeManager;
        $this->_urlInterface = $urlInterface;
    }

    public function getInstructions()
    {
        return trim($this->getConfigData('instructions'));
    }
    public function getDcvc()
    {
        return trim($this->getConfigData('smilepay_c2cp_dcvc'));
    }
    public function getVkey()
    {
        return trim($this->getConfigData('smilepay_c2cp_vkey'));
    }
    public function getRvg2c()
    {
        return trim($this->getConfigData('smilepay_c2cp_Rvg2c'));
    }
    public function getMid()
    {
        return trim($this->getConfigData('smilepay_c2cp_mid'));
    }
    public function getMidVal()
    {
        return trim($this->getConfigData('smilepay_c2cp_mid_val'));
    }
    public function getOrderPlaceRedirectUrl()
    {
        return  $this->_urlInterface->getUrl('smilepayc2cp/Pay/PlaceOrder', array('_secure' => false));
    }
    public function validate()
    {
       parent::validate();

       $objectManager = \Magento\Framework\App\ObjectManager::getInstance();

     

       $session  =  $objectManager->create('\Magento\Checkout\Model\Session');
       $quote_id = $session->getQuoteId();
       $quote = $objectManager->create('\Magento\Quote\Model\Quote')->load($quote_id );
       $billaddress = $quote->getBillingAddress();

       $name = $billaddress->getLastname() . $billaddress->getFirstname();
       $telephone = $billaddress->getTelephone();
       $shippingmethod = $objectManager->create('\Smilepay\Smilepayc2cp\Model\Shippingmethod');
       
       $shipping_method_code= $quote->getShippingAddress()->getShippingMethod();

       if( is_null($this->getDcvc()) || $this->getDcvc() == "" 
            || is_null($this->getVkey()) || $this->getVkey() == "" 
            || is_null($this->getRvg2c()) || $this->getRvg2c() == "" )
       {
           $errorCode = 'invalid_data';
           $errorMsg = __("smilepay_c2cp_vaildate_smse_config_error");
       }

       if( !preg_match("/[^a-zA-Z0-9 ]/",$name))
       {
           $limit_name_number =10;
       }
       else
       {
           $limit_name_number =5;
       }


       if(mb_strlen($name,"utf-8") > $limit_name_number )
       {
           $errorCode = 'invalid_data';
           $errorMsg = __("smilepay_c2cp_validate_name_error");
       }
       elseif( !preg_match("/^[0][9][0-9]{8,8}\$/", $telephone ))
       {
           $errorCode = 'invalid_data';
           $errorMsg = __("smilepay_c2cp_validate_phone_error");
       }
       elseif( strpos($shipping_method_code, 'smilepayc2cp_')!==0)
       {
           $errorCode = 'invalid_data';
           $errorMsg = __('smilepay_c2cp_validate_shippingmethod_error');
       }
       elseif(!$shippingmethod->isEmapSelected())
       {
           $errorCode = 'invalid_data';
           $errorMsg = __("smilepay_c2cp_validate_emap_error");
       }
     
       if (isset($errorMsg)) 
       {
           throw new \Magento\Framework\Exception\LocalizedException(
                new \Magento\Framework\Phrase($errorMsg)
            );
          // $this->logger->critical($errorMsg);
          // Mage::throwException($errorMsg);
       }

       return $this;
    }
}

?>