<?php
    
namespace  Smilepay\Smilepayc2cp\Model;
use Magento\Quote\Model\Quote\Address\RateRequest;
use Magento\Shipping\Model\Carrier\AbstractCarrier;
use Magento\Shipping\Model\Carrier\CarrierInterface;
use Magento\Shipping\Model\Rate\Result;


class Shippingmethod
extends \Magento\Shipping\Model\Carrier\AbstractCarrier
implements \Magento\Shipping\Model\Carrier\CarrierInterface
{
  protected $_code = 'smilepayc2cp';
  protected $emap_url = 'https://emap.presco.com.tw/c2cemap.ashx';
  protected $_isFixed = true;

   
  protected $_rateResultFactory;

  protected $_rateMethodFactory;
  protected $_storeManager;
  protected $_urlInterface;
  protected $_smilepayc2cp_session;
  protected $_checkout_session;
  protected $model_quote;
  const METHOD_FAMI = 'fami';
  const METHOD_711 = '711';
  protected $service_name = array(
                            self::METHOD_711,//711
                            self::METHOD_FAMI,
                        );
  protected $serivce_config = array(
                                self::METHOD_711=>array(
                                            'field_method_id'=>'smilepayc2cp',
                                            'field_active' =>'_711_active',
                                            'field_price'=> 'price',
                                            'field_name'=> 'name',
                                            
                                            'ret_controller'=>'saveEmap',
                                            'pay_subzg'=>'7NET',
                                            'csvTypeName'=>'7-11'
                                        ),
                                self::METHOD_FAMI=>array(
                                            'field_method_id'=>'fami',
                                            'field_active' =>'fami_active',
                                            'field_price'=> 'fami_price',
                                            'field_name'=> 'fami_name',

                                            'ret_controller'=>'saveEmapFami',
                                            'pay_subzg'=>'FAMI',
                                            'csvTypeName'=>'全家'
                                )
                            );
  private static $map_url = array(
                                    self::METHOD_711 => array(
                                                'mobile'=>'https://emap.presco.com.tw/c2cemapm-u.ashx?eshopid=870&servicetype=1&tempvar=%s&url=%s',
                                                'normal'=>'https://emap.presco.com.tw/c2cemap.ashx?eshopid=870&servicetype=1&tempvar=%s&url=%s'
                                                 ),
                                    self::METHOD_FAMI=>  array(
                                                 'mobile'=>'https://ssl.smse.com.tw/api/LogisticsEmap.asp?TypesServer=FAMIC2C&TypesInterface=WEB&tempvar=%s&url=%s',
                                                 'normal'=>'https://ssl.smse.com.tw/api/LogisticsEmap.asp?TypesServer=FAMIC2C&TypesInterface=WEB&tempvar=%s&url=%s'
                                                 ),
                                );
  
   protected static $service_cvs_query_shipment_url = array(
                                                            self::METHOD_711 => 'https://eservice.7-11.com.tw/E-Tracking/search.aspx',
                                                            self::METHOD_FAMI => 'http://www.famiport.com.tw/distribution_search.asp'          
                                                       );

  public function __construct(
        \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig,
        \Magento\Quote\Model\Quote\Address\RateResult\ErrorFactory $rateErrorFactory,
        \Psr\Log\LoggerInterface $logger,
        \Magento\Shipping\Model\Rate\ResultFactory $rateResultFactory,
        \Magento\Store\Model\StoreManagerInterface $storeManager,
        \Magento\Framework\UrlInterface $urlInterface,
        \Magento\Quote\Model\Quote\Address\RateResult\MethodFactory $rateMethodFactory,
        \Smilepay\Smilepayc2cp\Model\Session $smilepayc2cp_session,
        \Magento\Checkout\Model\Session $checkoutSession,
        \Magento\Quote\Model\Quote $model_quote,
        array $data = []
    ) {
        $this->_rateResultFactory = $rateResultFactory;
        $this->_rateMethodFactory = $rateMethodFactory;
        $this->_storeManager=$storeManager;
        $this->_urlInterface = $urlInterface;
        $this->_smilepayc2cp_session = $smilepayc2cp_session;
        $this->_checkout_session = $checkoutSession;
        $this->_model_quote = $model_quote;
        //map mobile start
        $useragent=$_SERVER['HTTP_USER_AGENT'];
        if( strpos( $useragent,'Android') === false && strpos($useragent,'iPad' ) === false && strpos( $useragent,'iPhone') === false
	        || strpos( $useragent,'Safari') === false && strpos( $useragent,'AppleWebKit') === false  && strpos( $useragent,'Dalvik') === false )
        {
            //pc
            $this->emap_url = "https://emap.presco.com.tw/c2cemap.ashx";
        }
        else
        {
            $this->emap_url = "https://emap.presco.com.tw/c2cemapm-u.ashx";
        }
        //map mobile end

        parent::__construct($scopeConfig, $rateErrorFactory, $logger, $data);

   }


  public function getMaxOrderTotal()
  {
    return $this->getConfigData('max_order_total');
  }
  public function getMinOrderTotal()
  {
    return $this->getConfigData('min_order_total');
  }

  public function getCurrencyLimit()
  {
    return trim($this->getConfigData('smilepay_c2cp_currency_limit'));
  }

  public function isActive()
  {
    $result=parent::isActive();
    if( $result)
    {
        if($this->getCurrencyLimit()==true)
        {
            if(  $this->_storeManager->getStore()->getCurrentCurrencyCode() != 'TWD')
                return false;
        }

    }
    return $result;
  }
  public function collectRates(RateRequest $request)
  {
    if (!$this->isActive()) 
    {
            return false;
    }
    //check total
    $total = $request->getBaseSubtotalInclTax()+$this->getConfigData('price');
    $minTotal = $this->getConfigData('min_order_total');
    $maxTotal = $this->getConfigData('max_order_total');
    $result = $this->_rateResultFactory->create();
    foreach($this->service_name as $service_id)
    {
        $total = $request->getBaseSubtotalInclTax()+$this->getConfigData($this->serivce_config[$service_id]['field_price']);
        
        if ((!empty($minTotal) && ($total < $minTotal)) || (!empty($maxTotal) && ($total > $maxTotal))) {
               continue;
        }    
        
        
        $result->append($this->_getDefaultRate($request,$service_id));
    }

    return $result;
  }
 
  public function getAllowedMethods()
  {
    $method = array();
    foreach($this->serivce_config as $service)
    {
         $method[$service['field_method_id']] = $this->getConfigData($service['field_name']);
    }

    return $method;
  }
 
  protected function _getDefaultRate(RateRequest $request,$service_id)
  {
    $rate =$this->_rateMethodFactory->create();
     
    $rate->setCarrier($this->_code);
    $rate->setCarrierTitle($this->getConfigData('title'));
  
    $rate->setMethod($this->serivce_config[$service_id]['field_method_id']);
    $rate->setMethodTitle($this->getConfigData($this->serivce_config[$service_id]['field_name']));
    $rate->setPrice($this->getConfigData( $this->serivce_config[$service_id]['field_price']));

    $rate->setCost(0);
    //free cost over specfic total
    if ($request->getFreeShipping() 
            ||( $this->getConfigData('free_shipping_enable') == 1  
            && !is_null( $this->getConfigData('free_shipping_subtotal'))
            && !empty($this->getConfigData('free_shipping_subtotal'))
            && $request->getBaseSubtotalInclTax() >= $this->getConfigData('free_shipping_subtotal'))
       )
    {
        $rate->setCost(0);
        $rate->setPrice(0.00);
    }
    return $rate;
  }





  public function getC2CpStoreData()
  {
      $session=$this->_smilepayc2cp_session;

      return $session->getSmilepayc2cpMapResult();

  }
  public function getC2CpStoreAddress()
  {
     
      $result = $this->getC2CpStoreData();
      return  $result['Storeaddress'];
  }
  public function getC2CpStoreId()
  {
      $result = $this->getC2CpStoreData();
      return  $result['Storeid'];
  }
  public function getC2CpStoreName()
  {
      $result = $this->getC2CpStoreData();
      return  $result['Storename'];
  }
  public function getC2CpCVSType()
  {
      $result = $this->getC2CpStoreData();
      return  $result['CVSType'];
  }
  //E-Map selected
  public function isEmapSelected()
  {
      $result = $this->getC2CpStoreData();
      $selected = true;
      $csvtype='';
      
      $session = $this->_checkout_session;
      $quote_id = $session->getQuoteId();
      $quote =$this->_model_quote->load( $quote_id);
      $shippingAddr = $quote->getShippingAddress();
      $shippingMethod = $shippingAddr->getShippingMethod();

      foreach($this->serivce_config as $service_id => $serivce)
      {
          if( $shippingMethod== $this->_code."_".$serivce['field_method_id'])
          {
            $csvtype= $service_id;
            break;
          }
      }
      if(!isset($result) || empty($result))
        $selected = false;
      else
      {
          foreach($result as $storeData)
          {
            if(!isset($storeData) || empty( $storeData))
            {
              $selected = false;
              break;
            }
          }
          if( $result['CVSType'] !=  $csvtype)
            $selected = false;
      }

      return  $selected;
  }
  public function isEmapSelectedAny()
  {
      $result = $this->getC2CpStoreData();
      $selected = true;
      

      
      if(!isset($result) || empty($result))
        $selected = false;
      else
      {
          foreach($result as $storeData)
          {
            if(!isset($storeData) || empty( $storeData))
            {
              $selected = false;
              break;
            }
          }
        
      }

      return  $selected;
  }
    // E-Map URL
  public function getEMapUrl($service_id='')
  {
     //map mobile start
     $useragent=$_SERVER['HTTP_USER_AGENT'];
     $isMobile=false;
     if( strpos( $useragent,'Android') === false && strpos($useragent,'iPad' ) === false && strpos( $useragent,'iPhone') === false
	        || strpos( $useragent,'Safari') === false && strpos( $useragent,'AppleWebKit') === false  && strpos( $useragent,'Dalvik') === false )
     {
        //pc
        $isMobile=false;
     }
     else
     {
        $isMobile=true;
     }
     //map mobile end
     if($isMobile)
        $emap_url = self::$map_url[$service_id]['mobile'];
     else
        $emap_url = self::$map_url[$service_id]['normal'];
    
     return sprintf( $emap_url,'', urlencode($this->_urlInterface->getBaseUrl()."smilepayc2cp/emap/".$this->serivce_config[$service_id]['ret_controller']));
  }
  public function checkoutShippingConfig()
  {
      return array(
                    $this->serivce_config[self::METHOD_711]['field_method_id']=>array(
                                            'emap_url'=>$this->getEMapUrl( self::METHOD_711)
                                        ),
                    $this->serivce_config[self::METHOD_FAMI]['field_method_id']=>array(
                                            'emap_url'=>$this->getEMapUrl( self::METHOD_FAMI)
                                        ),    
                );
  }
 
  public function convertCVSTypeToMethodid($csvtype)
  {
      return  isset($this->serivce_config[$csvtype]['field_method_id']) ? $this->serivce_config[$csvtype]['field_method_id']: '';
  }

  public function getPay_subzg($service_id)
  {
      return isset($this->serivce_config[$service_id]['pay_subzg'])? $this->serivce_config[$service_id]['pay_subzg'] :'';  
  }
  public function getCSVTypeName($service_id)
  {
      return isset($this->serivce_config[$service_id]['csvTypeName'])?$this->serivce_config[$service_id]['csvTypeName']:'';  
  }

  public function getShipmentQueryUrl($method)
  {
      foreach($this->serivce_config as $service_id => $serivce)
      {
          if( $method== $this->_code."_".$serivce['field_method_id'])
          {
            return self::$service_cvs_query_shipment_url[$service_id]; 
          }
         
      }
      return '';
  }

}
?>