<?php
namespace Smilepay\Smilepayc2cp\Observer;

use Magento\Framework\Event\ObserverInterface;
    use Magento\Framework\DataObject;
use Magento\Payment\Model\InfoInterface;
use Magento\Payment\Model\MethodInterface;
use Magento\Payment\Observer\AbstractDataAssignObserver;
use Magento\Sales\Model\Order\Invoice;
use Magento\Sales\Model\Order\Payment;
use Magento\Quote\Api\Data\PaymentMethodInterface;


class MatchPayment  implements ObserverInterface
{
    protected $_storeManager;
    protected $_orderFactory;
    protected $_smilepayc2cp_session;
    protected $_smilepayc2cp_paymentmethod;
    protected $_smilepayc2cp_helper_data;
    protected $_context;
    public function __construct(
        \Magento\Framework\App\Action\Context $context,
        \Magento\Sales\Model\Order $orderFactory,
        \Smilepay\Smilepayc2cp\Model\Session $smilepayc2cp_session,
        \Smilepay\Smilepayc2cp\Model\Paymentmethod $smilepayc2cp_paymentmethod,
        \Magento\Store\Model\StoreManagerInterface $storeManager,
        \Smilepay\Smilepayc2cp\Helper\Data   $smilepayc2cp_helper_data)
    {
        $this->_storeManager = $storeManager;
        $this->_orderFactory = $orderFactory;
        $this->_smilepayc2cp_session = $smilepayc2cp_session;
        $this->_smilepayc2cp_paymentmethod = $smilepayc2cp_paymentmethod;
        $this->_smilepayate_helper_data=$smilepayc2cp_helper_data;
        $this->_context =$context;
    }

  //generate order info to checkout success
  public function execute(\Magento\Framework\Event\Observer $observer)
  {
   /* $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
    $requestObj = $objectManager->get('Magento\Framework\App\Request\Http'); 
    $controllerName= $requestObj->getModuleName()."/" . $requestObj->getControllerName() ."/". $requestObj->getActionName();

    $controllerName= strtolower($controllerName);
   */
    $event = $observer->getEvent();
    $method = $event->getMethodInstance();
    $result = $event->getResult(); 

    $quote  = $event->getQuote();

    
    if(isset($quote))
    {
        
        $shippingAddr = $quote->getShippingAddress();
        $shippingMethod = $shippingAddr->getShippingMethod();

       
    }
    else
        return;
 
    

    //if($controllerName != 'checkout/index/index')
      //  return;
    
        
    if(strpos($shippingMethod, 'smilepayc2cp_')===0) //shipping match
    {
        if($method->getCode() != 'smilepayc2cp') 
        {
           
            if(!is_null($result->getData('is_available')))
              $result->setData('is_available',false); 
        }
   
    }
    else
    {
        if($method->getCode() == 'smilepayc2cp')  // hide
        {
            $result->setData('is_available',false); 
        }
    }
    
  }
}


?>