<?php
namespace Smilepay\Smilepayc2cp\Observer;

use Magento\Framework\Event\ObserverInterface;
    use Magento\Framework\DataObject;
use Magento\Payment\Model\InfoInterface;
use Magento\Payment\Model\MethodInterface;
use Magento\Payment\Observer\AbstractDataAssignObserver;
use Magento\Sales\Model\Order\Invoice;
use Magento\Sales\Model\Order\Payment;
use Magento\Quote\Api\Data\PaymentMethodInterface;


class PlaceOrderSuccess  implements ObserverInterface
{
    protected $_storeManager;
    protected $_orderFactory;
    protected $_smilepayc2cp_session;
    protected $_smilepayc2cp_paymentmethod;
    protected $_smilepayc2cp_helper_data;
    protected $_context;
    public function __construct(
        \Magento\Framework\App\Action\Context $context,
        \Magento\Sales\Model\Order $orderFactory,
        \Smilepay\Smilepayc2cp\Model\Session $smilepayc2cp_session,
        \Smilepay\Smilepayc2cp\Model\Paymentmethod $smilepayc2cp_paymentmethod,
        \Magento\Store\Model\StoreManagerInterface $storeManager,
        \Smilepay\Smilepayc2cp\Helper\Data   $smilepayc2cp_helper_data)
    {
        $this->_storeManager = $storeManager;
        $this->_orderFactory = $orderFactory;
        $this->_smilepayc2cp_session = $smilepayc2cp_session;
        $this->_smilepayc2cp_paymentmethod = $smilepayc2cp_paymentmethod;
        $this->_smilepayc2cp_helper_data=$smilepayc2cp_helper_data;
        $this->_context =$context;
    }

  //generate order info to checkout success
  public function execute(\Magento\Framework\Event\Observer $observer)
  {
      $event = $observer->getEvent();
    
      $order_id = $event->getOrderIds()[0];

      if(!isset($order_id) || empty($order_id))
          return;
      $order =$this->_orderFactory;
      $order->load($order_id);

      $paymentmethod = $order->getPayment()->getMethod();

      if( trim($paymentmethod) == 'smilepayc2cp')
      {
          $controlleraction = $this->_context->getView();


          /*$block = $controlleraction->getLayout()->createBlock('Magento\Framework\View\Element\Template','smilepayc2cp_message',
                                                                                                                        array('data'=> 
                                                                                                                                array('template' => 'Smilepay_Smilepayc2cp::placeorder/success.phtml')
                                                                                                                         ));*/

          //$block =$controlleraction->getLayout()->addBlock('Magento\Framework\View\Element\Template','smilepayc2cp_message','order.success.additional.info');
          $block =$controlleraction->getLayout()->addBlock('Magento\Framework\View\Element\Template','smilepayc2cp_message','content');    
          $block->setTemplate('Smilepay_Smilepayc2cp::placeorder/success.phtml');
          $session= $this->_smilepayc2cp_session;
          $smilepayc2cp_result=$session->getSmilepayc2cpResult();
          $smilepayc2cp_model= $this->_smilepayc2cp_paymentmethod;


       

          $block->assign(
                        array(
                            'smilepay_c2cp_title' =>   $smilepayc2cp_model->getTitle(),
                            'smilepay_c2cp_status' =>  $smilepayc2cp_result['Status'],
                            'smilepay_c2cp_storename' =>$smilepayc2cp_result['Storename'],
                            'smilepay_c2cp_storeaddress' => $smilepayc2cp_result['Storeaddress'],
                            'smilepay_c2cp_amount' => $smilepayc2cp_result['Amount'],
                            'smilepay_c2cp_storeid' => $smilepayc2cp_result['Storeid'],
                            'smilepay_c2cp_pur_name' => $smilepayc2cp_result['Pur_name'],
                            'smilepay_c2cp_data_id' => $smilepayc2cp_result['Data_id'],
                            'smilepay_c2cp_mobile_number' => $smilepayc2cp_result['Mobile_number'],
                             )
                    );
          $session->clearStorage();
          $controlleraction->getLayout()->reorderChild("content",'smilepayc2cp_message','checkout.success',false);


      
      //    $controlleraction->getLayout()->getBlock('checkout.success')->insert($block,'',false);
     
      }
    
  }
}


?>