define(
    [
         'Magento_Checkout/js/model/quote',
    ],
    function (quote) {
        "use strict";
        return {
            smilepayc2cp_emap_url:"",
            smilepayc2cp_emap_btn_text:["選擇取貨門市","重新選擇取貨門市"],
            isSmilepayc2cpSelected: function () {
                if(quote.shippingMethod() )
                {
                    var selected_shipping_code =  quote.shippingMethod().carrier_code + '_' + quote.shippingMethod().method_code;
                      
                    if(selected_shipping_code.indexOf('smilepayc2cp_')==0)
                        return true;
                    else
                        return false;
                }
                       
            },
            getSmilepayc2cpBlock: function(){
                return window.checkoutConfig.shipping.block['smilepayc2cp'];
            },
            getSmilepayc2cpStoreInfoBlock: function(){
                return window.checkoutConfig.shipping.block['smilepayc2cp_storeinfo'];
            },
            getSmilepayc2cpStoreData: function(){
            
                return { "StoreId":window.checkoutConfig.shipping.data.smilepayc2cp.storeId,
                   "StoreName": window.checkoutConfig.shipping.data.smilepayc2cp.storeName,
                   "StoreAddr": window.checkoutConfig.shipping.data.smilepayc2cp.storeAddr,
                   'CSVStoreType':window.checkoutConfig.shipping.data.smilepayc2cp.cvsstoreType,
                    };
            },
            getCurrentEmapUrl: function()
            {
                var method_code=quote.shippingMethod().method_code;
                return  window.checkoutConfig.shipping.data.smilepayc2cp[method_code]['emap_url'];
            },
            
            getSmilepayc2cpStoreSelected: function(){ 
                if(quote.shippingMethod() )
                {
                    var method_code = quote.shippingMethod().method_code;
                
                    if(method_code == window.checkoutConfig.shipping.data.smilepayc2cp.cvsstoreType)
                        return window.checkoutConfig.shipping.data.smilepayc2cp.selected;      
                    else
                        return false;  
                }
            },

            isSmilepayc2cpPaymentSelected: function()
            {
            
                var method = quote.paymentMethod();
                var method_code = quote.paymentMethod().method;

                if(method_code == "smilepayc2cp")
                    return true;
                else
                    return false;
            },

            isSmilepayc2cpCustomerNameValid: function()
            {
                var shippingAddr= quote.shippingAddress();
              
                var name = shippingAddr.lastname + shippingAddr.firstname;
                var maxlen = 10;
                if(!name.match(/^[a-zA-Z0-9\s]+$/))
                {
                    maxlen = 5;
                }
                if(name.length > maxlen)
                {
                    return false;
                }else
                    return true;
                
            },
            isSmilepayc2cpCustomerPhoneValid: function()
            {
                var shippingAddr= quote.shippingAddress();
                var re=/^[0][9][0-9]{8,8}$/;
                var phone = shippingAddr.telephone;
                
                if(!phone.match(re))
                {
                   return false;
                }
              
                return true;
            }

         };
    }
);
