<?php

namespace  Smilepay\Smilepayc2cup\Model;

use Magento\Checkout\Model\ConfigProviderInterface;
use Magento\Framework\Escaper;
use Magento\Payment\Helper\Data as PaymentHelper;
use Magento\Framework\View\LayoutInterface;

class Smilepayc2cupConfigProvider implements ConfigProviderInterface
{
    /**
     * @var string[]
     */


    /**
     * @var \Magento\Payment\Model\Method\AbstractMethod[]
     */
    protected $methods = [];

    /**
     * @var Escaper
     */
    protected $escaper;

    protected $_smilepayc2cup_shipping_method;
    protected $_layout;
    /**
     * @param PaymentHelper $paymentHelper
     * @param Escaper $escaper
     */
    public function __construct(
        PaymentHelper $paymentHelper,
        \Smilepay\Smilepayc2cup\Model\Shippingmethod $smilepayc2cup_shipping_method,
        LayoutInterface $layout,
        Escaper $escaper
    ) {
        $this->escaper = $escaper;
        /*foreach ($this->methodCodes as $code) {
            $this->methods[$code] = $paymentHelper->getMethodInstance($code);
        }*/
       
        $this->_smilepayc2cup_shipping_method = $smilepayc2cup_shipping_method;
        $this->_layout = $layout;
    }

    /**
     * {@inheritdoc}
     */
    public function getConfig()
    {
        $config = [];
       /* foreach ($this->methodCodes as $code) {
            if ($this->methods[$code]->isAvailable()) {
                $config['payment']['instructions'][$code] = $this->getInstructions($code);
            }
        }*/

        $config['shipping']['block']['smilepayc2cup'] = $this->getShippingBlock('Emap');
        $config['shipping']['block']['smilepayc2cup_storeinfo'] = $this->getShippingBlock('EmapStoreInfo');

        $c2cdata= $this->getC2CDATA();


        foreach( $c2cdata as $key=>$val)
        {
            $config['shipping']['data']['smilepayc2cup'][$key]= $val; 
        }
        $shipping_config=$this->_smilepayc2cup_shipping_method->checkoutShippingConfig();
        foreach( $shipping_config as $service_key=>$serive)
        {
            foreach( $serive as $key=>$val)
                $config['shipping']['data']['smilepayc2cup'][$service_key][$key]= $val; 
        }

        return $config;
    }

    /**
     * Get instructions text from config
     *
     * @param string $code
     * @return string
     */
    protected function getInstructions($code)
    {
        return nl2br($this->escaper->escapeHtml($this->methods[$code]->getInstructions()));
    }

    protected function getC2CDATA()
    {
        if($this->_smilepayc2cup_shipping_method->isEmapSelectedAny())
        {
            return array(
                        'storeId' =>$this->_smilepayc2cup_shipping_method->getC2CupStoreId(),
                        'storeName' =>$this->_smilepayc2cup_shipping_method->getC2CupStoreName(),
                        'storeAddr' =>$this->_smilepayc2cup_shipping_method->getC2CupStoreAddress(), 
                        'cvsstoreType' =>$this->_smilepayc2cup_shipping_method->convertCVSTypeToMethodid($this->_smilepayc2cup_shipping_method->getC2CupCVSType()), 
                        'selected' => true,
                    );
        }
        else    
            return array( 'selected' => false);
        return NULL;
    }

    protected function getShippingBlock($blockname)
    {
        $block=$this->_layout->createBlock('Smilepay\Smilepayc2cup\Block\Checkout\Shipping\\'. $blockname);
       
        return  $block->toHtml();
    }
}

?>