<?php
namespace Smilepay\Smilepayc2cup\Observer;

use Magento\Framework\Event\ObserverInterface;
    use Magento\Framework\DataObject;
use Magento\Payment\Model\InfoInterface;
use Magento\Payment\Model\MethodInterface;
use Magento\Payment\Observer\AbstractDataAssignObserver;
use Magento\Sales\Model\Order\Invoice;
use Magento\Sales\Model\Order\Payment;
use Magento\Quote\Api\Data\PaymentMethodInterface;


class PlaceOrderSuccess  implements ObserverInterface
{
    protected $_storeManager;
    protected $_orderFactory;
    protected $_smilepayc2cup_session;
    protected $_smilepayc2cup_helper_data;
    protected $_smilepayc2cup_shippingmethod;

    protected $_context;
    public function __construct(
        \Magento\Framework\App\Action\Context $context,
        \Magento\Sales\Model\Order $orderFactory,
        \Smilepay\Smilepayc2cup\Model\Session $smilepayc2cup_session,
        \Magento\Store\Model\StoreManagerInterface $storeManager,
        \Smilepay\Smilepayc2cup\Helper\Data   $smilepayc2cup_helper_data,
        \Smilepay\Smilepayc2cup\Model\Shippingmethod   $smilepayc2cup_shippingmethod
        
        )
    {
        $this->_storeManager = $storeManager;
        $this->_orderFactory = $orderFactory;
        $this->_smilepayc2cup_session = $smilepayc2cup_session;
        $this->_smilepayc2cup_helper_data=$smilepayc2cup_helper_data;
        $this->_smilepayc2cup_shippingmethod =  $smilepayc2cup_shippingmethod;
        $this->_context =$context;
    }

  //generate order info to checkout success
  public function execute(\Magento\Framework\Event\Observer $observer)
  {
      $event = $observer->getEvent();
    
      $order_id = $event->getOrderIds()[0];

      if(!isset($order_id) || empty($order_id))
          return;
      $order =$this->_orderFactory;
      $order->load($order_id);
      $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
      $quote = $objectManager->create('\Magento\Quote\Model\Quote');
      $quote->load($order->getQuoteId());




      $shippingmethod = $quote->getShippingAddress()->getShippingMethod();
      if(strpos(trim($shippingmethod), 'smilepayc2cup_')===0 )
      {
          $controlleraction = $this->_context->getView();

          $session= $this->_smilepayc2cup_session;
          $smilepayc2cup_model= $this->_smilepayc2cup_shippingmethod;
         //run process
          $smilepayc2cup_result = $smilepayc2cup_model->runC2CupProcess( $order->getIncrementId());
          $block = $smilepayc2cup_model->generateC2CupOrderBlock($smilepayc2cup_result);

          $session->clearStorage();

          /*$block = $controlleraction->getLayout()->createBlock('Magento\Framework\View\Element\Template','smilepayc2cup_message',
                                                                                                                        array('data'=> 
                                                                                                                                array('template' => 'Smilepay_Smilepayc2cup::placeorder/success.phtml')
                                                                                                                         ));*/
          
         


          /*$checkout_success_block=$controlleraction->getLayout()->getBlock('checkout.success');

          if($checkout_success_block)
               $checkout_success_block->insert($block,'checkout.success',false);
          else
               $checkout_success_block->insert($block,'',false);*/


          //$block =$controlleraction->getLayout()->addBlock(   $block,'','order.success.additional.info');  
          $block =$controlleraction->getLayout()->addBlock(   $block,'','content');  
          $controlleraction->getLayout()->reorderChild("content",$block->getNameInLayout(),999,false);
     
      }
    
  }
}


?>