<?php
namespace Smilepay\Smilepaycredit\Controller;

abstract class SmilepaycreditController extends \Magento\Framework\App\Action\Action 
{
    protected $smseResult;
    protected $smseurl='https://ssl.smse.com.tw/ezpos/mtmk_utf.asp';
    protected $_checkoutSession;
    protected $_orderFactory;
    protected $_smilepaycredit_session;
    protected $_smilepaycredit_paymentmethod;
    protected $_smilepaycredit_helper_data;
    protected $_resultPageFactory;
    protected $_urlInterface;

    public function __construct(
        \Magento\Framework\App\Action\Context $context,
        \Magento\Framework\View\Result\PageFactory $resultPageFactory,
        \Magento\Checkout\Model\Session $checkoutSession,
        \Magento\Sales\Model\Order $orderFactory,
        \Smilepay\Smilepaycredit\Model\Session $smilepaycredit_session,
        \Smilepay\Smilepaycredit\Model\Paymentmethod $smilepaycredit_paymentmethod,
        \Smilepay\Smilepaycredit\Helper\Data   $smilepaycredit_helper_data
      
    ) {
        $this->_checkoutSession = $checkoutSession;
        $this->_orderFactory = $orderFactory;
        $this->_smilepaycredit_session = $smilepaycredit_session;
        $this->_smilepaycredit_paymentmethod = $smilepaycredit_paymentmethod;
        $this->_smilepaycredit_helper_data=$smilepaycredit_helper_data;
        $this->_resultPageFactory = $resultPageFactory;
       // $this->_urlInterface = $urlInterface;
        $this->_urlInterface =$context->getUrl();
        parent::__construct($context);
    }
      

    protected function connectionSmse()
    {
        $session = $this->_checkoutSession;
        $quote = $session->getQuote();
        $order = $this->_orderFactory;
        $order_id = $session->getLastOrderId();
        //$url='https://ssl.smse.com.tw/api/SPPayment.asp';
        $order->load($order_id);
        if($order->getId()==0)
        {
           $this->_redirect('checkout/cart');
           return FALSE;
           // throw new \Exception("Error not found Order");
        }
        $customer_name = $order->getBillingAddress()->getLastname() . $order->getBillingAddress()->getFirstname() ;
        $customer_email=$order->getCustomerEmail();
        $phone = $order->getBillingAddress()->getTelephone();
        $billAddress=$order->getBillingAddress();
        $address=  $billAddress->getData('region') . " " . $billAddress->getData('city') ." " .  $billAddress->getData('street');
        $paymentmethod=$this->_smilepaycredit_paymentmethod;

        if($paymentmethod->getCurrencyLimit()==true)
        {
            $total = $order->getGrandTotal();
        }
        else
        {
            //find TWD selected?
            if($this->_smilepaycredit_helper_data->isCurrencyTWDselected())
                $total = $order->getGrandTotal();
            else
                $total = $order->getBaseGrandTotal();
        }

        $postdata = array(
                        'Dcvc' =>trim( $paymentmethod->getDcvc()),
                        'Rvg2c' => trim($paymentmethod->getRvg2c()),
                        'Verify_key' =>trim($paymentmethod->getVkey()),
                        'Pay_gdry' =>'TW',
                        'Od_sob' => $session->getLastRealOrderId(),
                        'Pay_zg' => 1,
                        //'Pay_subzg' => '7NET',
                        'Data_id' => $session->getLastRealOrderId(),
                        'Amount' => intval(round( $total)),
                        'Pur_name' => $customer_name,
                        'Tel_number' =>  $phone,
                        'Mobile_number' => $phone,
                       // 'Address' => $address,
                        'Email' => $customer_email,
                        'Roturl' =>  $this->_urlInterface->getUrl("smilepaycredit/Pay/paid") ,
                 //       'Roturl_status'=>'magento1.8.1_Ok',
                    );
        $resultPage = $this->_resultPageFactory->create();
     
       // $block = $resultPage->getLayout()->createBlock('Magento\Framework\View\Element\Template','smilepaycredit_sendform');
        $block = $resultPage->getLayout()->addBlock('Magento\Framework\View\Element\Template','smilepay_credit_place_order','content');
        $block->assign(  
                    array(
                        'smilepay_credit_postdata'=>$postdata,
                        'smilepay_credit_action_url'=> $this->smseurl,
                        )
                    );
   
        $block->setTemplate('Smilepay_Smilepaycredit::placeorder/send.phtml');
       
        //echo $block->toHtml();
        
        //return $resultPage ;

    }
    
    function getSession()
    {
        return $this->_smilepaycredit_session;
    }

    protected function midfun($Mid_value,$Amount,$Smseid,$Mid_smilepay)
    {   
        $Amount = str_pad($Amount,8,'0',STR_PAD_LEFT);                   
        $Smseid= preg_replace('/[\D]/i','9',substr($Smseid,-4));      
        $dtotal=$Mid_value.$Amount.$Smseid;                              
      
        $i = 1;
        $sum = strlen($dtotal);
        $etemp=0;      
        while ($i <= $sum)
        {
            $ep = substr($dtotal,$i,1);
            $etemp = $etemp + $ep;                
            $i=$i+2;
        }                
      
        $i = 0;  
        $otemp=0;          
        while ($i <= $sum)
        {                                              
            $op = substr($dtotal,$i,1);
            $otemp = $otemp + $op;
            $i=$i+2;
        }
        $mid=($etemp*3)+($otemp*9);    
      
        if($Mid_smilepay == $mid){
            return true;
        }else{
            return false;
        }            
    }   	
  	

}

?>