<?php

namespace  Smilepay\Smilepaycredit\Model;


use Magento\Quote\Api\Data\CartInterface;

use Magento\Framework\DataObject;
use Magento\Payment\Model\InfoInterface;
use Magento\Payment\Model\MethodInterface;
use Magento\Payment\Observer\AbstractDataAssignObserver;
use Magento\Sales\Model\Order\Invoice;
use Magento\Sales\Model\Order\Payment;
use Magento\Quote\Api\Data\PaymentMethodInterface;

class Paymentmethod extends \Magento\Payment\Model\Method\AbstractMethod
{
    const PAYMENT_METHOD_SMILEPAYCREDIT_CODE =  'smilepaycredit';
    protected $_code  = self::PAYMENT_METHOD_SMILEPAYCREDIT_CODE;

    /**
     * Cash On Delivery payment block paths
     *
     * @var string
     */
     
    protected $_formBlockType ="Smilepay\\Smilepaycredit\\Block\\Form\\Smilepaycreditcheckout";
    protected $_infoBlockType = "Smilepay\\Smilepaycredit\\Block\\Info\\Smilepaycreditcheckout";
    //protected $_infoBlockType = 'payment/info';
    protected $_smilepaycredit_helper_data;
    protected $_storeManager;
    protected $_urlInterface;

    public function __construct(
        \Magento\Framework\Model\Context $context,
        \Magento\Framework\Registry $registry,
        \Magento\Framework\Api\ExtensionAttributesFactory $extensionFactory,
        \Magento\Framework\Api\AttributeValueFactory $customAttributeFactory,
        \Magento\Payment\Helper\Data $paymentData,
        \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig,
        \Magento\Payment\Model\Method\Logger $logger,
        \Smilepay\Smilepaycredit\Helper\Data   $smilepaycredit_helper_data,
        \Magento\Store\Model\StoreManagerInterface $storeManager,
        \Magento\Framework\UrlInterface $urlInterface,
        \Magento\Framework\Model\ResourceModel\AbstractResource $resource = null,
        \Magento\Framework\Data\Collection\AbstractDb $resourceCollection = null,
        array $data = []
    ) {

        parent::__construct(
            $context,
            $registry,
            $extensionFactory,
            $customAttributeFactory,
            $paymentData,
            $scopeConfig,
            $logger,
            $resource,
            $resourceCollection,
            $data
        );
        $this->_smilepaycredit_helper_data=$smilepaycredit_helper_data;
        $this->_storeManager=$storeManager;
        $this->_urlInterface = $urlInterface;
    }


    public function getInstructions()
    {
        return trim($this->getConfigData('instructions'));
    }
    public function getDcvc()
    {
        return trim($this->getConfigData('smilepay_credit_dcvc'));
    }
    public function getVkey()
    {
        return trim($this->getConfigData('smilepay_credit_vkey'));
    }
    public function getRvg2c()
    {
        return trim($this->getConfigData('smilepay_credit_Rvg2c'));
    }
    public function getMid()
    {
        return trim($this->getConfigData('smilepay_credit_mid'));
    }
    public function getMidVal()
    {
        return trim($this->getConfigData('smilepay_credit_mid_val'));
    }
    public function getOrderPlaceRedirectUrl()
    {
        return $this->_urlInterface->getUrl('smilepaycredit/Pay/PlaceOrder', array('_secure' => false));
    }

    public function validate()
    {
       parent::validate();

       if( is_null($this->getDcvc()) || $this->getDcvc() == "" 
            || is_null($this->getVkey()) || $this->getVkey() == "" 
            || is_null($this->getRvg2c()) || $this->getRvg2c() == "" )
       {
           $errorCode = 'invalid_data';
           $errorMsg = __("smilepay_credit_vaildate_smse_config_error");
       }

       if (isset($errorMsg)) 
       {
           throw new \Magento\Framework\Exception\LocalizedException(
               new \Magento\Framework\Phrase($errorMsg)
            );
       }
    }
    public function getCurrencyLimit()
    {
        return trim($this->getConfigData('smilepay_credit_currency_limit'));
    }

    public function isAvailable(CartInterface $quote = null)
    {
        $result=parent::isAvailable($quote );

        if( $result)
        {
            if($this->getCurrencyLimit()==true)
            {
                if( $this->_storeManager->getStore()->getCurrentCurrencyCode() != 'TWD')
                    return false;
            }
        }

        return $result;

    }
}

?>