<?php
namespace Smilepay\Smilepaycsv\Controller\Barcode;
class Billgen extends \Magento\Framework\App\Action\Action  
{
    protected $_checkoutSession;
    protected $_orderFactory;
    protected $_smilepayatm_session;
    protected $_smilepayatm_paymentmethod;
    protected $_smilepayatm_helper_data;
    protected $_resultPageFactory;
    protected $_urlInterface;
    protected $_storeInfo;
    protected $_storeManager;
    protected $_store;

    public function __construct(
        \Magento\Framework\App\Action\Context $context,
        \Magento\Framework\View\Result\PageFactory $resultPageFactory,
        \Magento\Checkout\Model\Session $checkoutSession,
        \Magento\Sales\Model\Order $orderFactory,
        \Smilepay\Smilepaycsv\Model\Session $smilepaycsv_session,
        \Smilepay\Smilepaycsv\Model\Paymentmethod $smilepaycsv_paymentmethod,
        \Smilepay\Smilepaycsv\Helper\Data   $smilepaycsv_helper_data,
        \Magento\Store\Model\Information $storeInfo,
        \Magento\Store\Model\Store $store,
        \Magento\Store\Model\StoreManagerInterface $storeManager
       
    ) {
        $this->_checkoutSession = $checkoutSession;
        $this->_orderFactory = $orderFactory;
        $this->_smilepaycsv_session = $smilepaycsv_session;
        $this->_smilepaycsv_paymentmethod = $smilepaycsv_paymentmethod;
        $this->_smilepaycsv_helper_data=$smilepaycsv_helper_data;
        $this->_resultPageFactory = $resultPageFactory;
     //   $this->_urlInterface = $urlInterface;
      $this->_urlInterface =$context->getUrl();
        $this->_storeInfo = $storeInfo;
        $this->_storeManager = $storeManager;
        $this->_store = $store;
        parent::__construct($context);
    }




    public function execute()
    {
        $resultPage = $this->_resultPageFactory->create();

        if(isset($_REQUEST['realOrderId']))
            $realOrderId=$_REQUEST['realOrderId'];
        else
        {
            $errormsg['realOrderId_error'] = __('smilepay_csv_bill_orderid_error');
            $this->_checkoutSession->addError($errormsg['realOrderId_error']);
            $this->_redirect("checkout/cart");
            $this->getResponse()->sendHeaders()
                ->sendResponse();
         //    $this->getResponse()->setRedirect($this->getUrl("checkout/cart"));
        }
        /*
        if(isset($_REQUEST['offset']))
            $offset=$_REQUEST['offset'];
        else
            $offset=0;
            */
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $resource = $objectManager->create('Magento\Framework\App\ResourceConnection'); 
        $db_read= $resource->getConnection();

       
        if(isset($db_read))
        {
            if(isset($_REQUEST['vcode']))
                $code= $_REQUEST['vcode'];
            else
                $code = "0";
        
            if($db_read->isTableExists(trim($resource->getTableName('smilepaycsv_record'))))
            {
                $tableName = $resource->getTableName('smilepaycsv_record');
                $results = $db_read->fetchAll("select barcode1,barcode2,barcode3,dateline from $tableName where order_increment_id='" .$realOrderId ."' AND `barcode1` = '$code'  ORDER BY record_id DESC limit 1");
                
              //  $this->_redirect("checkout/cart");
            }
            else
            {
                $errormsg['db_error'] = __('smilepay_csv_bill_database_error');
                $this->_checkoutSession->addError($errormsg['db_error']);
            
            }
          //  $db_read->closeConnection();
            
        }
        else
        {
            $errormsg['db_error'] = __('smilepay_csv_bill_database_error');
            $this->_checkoutSession->addError($errormsg['db_error']);
        }
        
   

        if(isset($errormsg))
        {
            $this->getResponse()->sendHeaders()
                ->sendResponse();
            $this->_redirect("checkout/cart");
        }

        if(!isset($results) || empty($results))
        {
            $errormsg['db_error'] = __('smilepay_csv_bill_not_in_database_error');

            $this->_checkoutSession->addError($errormsg['db_error']);

           // $this->getResponse()->setRedirect(Mage::getUrl("checkout/cart"));
            $this->_redirect("checkout/cart");
            $this->getResponse()->sendHeaders()
                ->sendResponse();
            exit;
        }
        $order = $this->_orderFactory->loadByIncrementId($realOrderId);
     
        
        $smilepaycsv_model= $this->_smilepaycsv_paymentmethod;

      //  $block = $resultPage->getLayout()->createBlock('Magento\Framework\View\Element\Template','smilepaycsv_message',array('template' => 'Smilepay_Smilepaycsv::placeorder/generatebill.phtml'));
        $block = $resultPage->getLayout()->addBlock('Magento\Framework\View\Element\Template','smilepaycsv_message','content');
        $block->setTemplate('Smilepay_Smilepaycsv::placeorder/generatebill.phtml');

        if($order->getOrderCurrencyCode()=='TWD')
            $total= intval(round($order->getGrandTotal()));
        else
            $total= intval(round($order->getBaseGrandTotal()));

        

        $block->assign(
                        array(
                            'smilepay_csv_title' =>   $smilepaycsv_model->getTitle(),
                            'smilepay_csv_storeName' => $this->_storeManager->getStore()->getName(),
                            'smilepay_csv_status' => 1,
                            'smilepay_csv_data_id' =>  $realOrderId,
                            'smilepay_csv_barcode1' =>  $results[0]['barcode1'],
                            'smilepay_csv_barcode2' =>  $results[0]['barcode2'],
                            'smilepay_csv_barcode3' =>  $results[0]['barcode3'],
                            'smilepay_csv_amount' =>  $total,
                            'smilepay_csv_dateline' =>  $results[0]['dateline'],
                            'smilepay_csv_store_url'=>$this->_storeManager->getStore()->getBaseUrl(),
                            'smilepay_csv_store_phone'=> $this->_storeInfo->getStoreInformationObject($this->_store)->getPhone(),
                            'smilepay_csv_barcode_gen_url'=>$this->_storeManager->getStore()->getBaseUrl() ."smilepaycsv/barcode/barcodegen",
                             )
                    );
       
        //$this->loadLayout();
       // $resultPage->getLayout()->getBlock('content')->insert($block,'',false);
       // $this->renderLayout();
        return $resultPage;
    }

}

?>