<?php
namespace Smilepay\Smilepaycsv\Controller;

abstract class SmilepaycsvController extends \Magento\Framework\App\Action\Action 
{
    protected $smseResult;
    protected $_checkoutSession;
    protected $_orderFactory;
    protected $_smilepaycsv_session;
    protected $_smilepaycsv_paymentmethod;
    protected $_smilepaycsv_helper_data;
    protected $_resultPageFactory;
    protected $_urlInterface;

    public function __construct(
        \Magento\Framework\App\Action\Context $context,
        \Magento\Framework\View\Result\PageFactory $resultPageFactory,
        \Magento\Checkout\Model\Session $checkoutSession,
        \Magento\Sales\Model\Order $orderFactory,
        \Smilepay\Smilepaycsv\Model\Session $smilepaycsv_session,
        \Smilepay\Smilepaycsv\Model\Paymentmethod $smilepaycsv_paymentmethod,
        \Smilepay\Smilepaycsv\Helper\Data   $smilepaycsv_helper_data
    ) {
        $this->_checkoutSession = $checkoutSession;
        $this->_orderFactory = $orderFactory;
        $this->_smilepaycsv_session = $smilepaycsv_session;
        $this->_smilepaycsv_paymentmethod = $smilepaycsv_paymentmethod;
        $this->_smilepaycsv_helper_data=$smilepaycsv_helper_data;
        $this->_resultPageFactory = $resultPageFactory;
    //    $this->_urlInterface = $urlInterface;
        $this->_urlInterface = $context->getUrl();
        parent::__construct($context);
    }


    protected function connectionSmse()
    {
        $session =  $this->_checkoutSession;
        $quote = $session->getQuote();
        $order = $this->_orderFactory;
        $order_id = $session->getLastOrderId();
        $url='https://ssl.smse.com.tw/api/SPPayment.asp';
        $order->load($order_id);
        if($order->getId()==0)
        {
           $this->_redirect('checkout/cart');
           return FALSE;
           // throw new \Exception("Error not found Order");
        }
        $customer_name = $order->getBillingAddress()->getLastname() . $order->getBillingAddress()->getFirstname() ;
        $customer_email=$order->getCustomerEmail();
        $phone = $order->getBillingAddress()->getTelephone();
        $billAddress=$order->getBillingAddress();
        $address=  $billAddress->getData('region') . " " . $billAddress->getData('city') ." " .  $billAddress->getData('street');
        $paymentmethod=$this->_smilepaycsv_paymentmethod;


        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $resource = $objectManager->create('Magento\Framework\App\ResourceConnection'); 
        $db_write= $resource->getConnection();
        
        //database error
        if(!isset($db_write))
        {
            
            $errormsg['db_error'] = __('smilepay_csv_bill_database_error');
            $this->_checkoutSession->addError($errormsg['db_error']);
            $this->_redirect("checkout/cart");
        }
        else
        {
            if(!$db_write->isTableExists($resource->getTableName('smilepaycsv_record')))
            {
                $errormsg['db_error'] = __('smilepay_csv_bill_database_error');
                $this->_checkoutSession->addError($errormsg['db_error']);
                $this->_redirect("checkout/cart");
            }
            
        }
        if($paymentmethod->getCurrencyLimit()==true)
        {
            $total = $order->getGrandTotal();
        }
        else
        {
            //find TWD selected?
            if($this->_smilepaycsv_helper_data->isCurrencyTWDselected())
                $total = $order->getGrandTotal();
            else
                $total = $order->getBaseGrandTotal();
        }
        $postdata = array(
                        'Dcvc' =>trim( $paymentmethod->getDcvc()),
                        'Rvg2c' => trim($paymentmethod->getRvg2c()),
                        'Verify_key' =>trim($paymentmethod->getVkey()),
                        'Pay_gdry' =>'TW',
                        'Od_sob' => $session->getLastRealOrderId(),
                        'Pay_zg' => 3,
                        //'Pay_subzg' => '7NET',
                        'Data_id' => $session->getLastRealOrderId(),
                        'Amount' => intval(round($total)),
                        'Pur_name' => $customer_name,
                        'Tel_number' =>  $phone,
                        'Mobile_number' => $phone,
                       // 'Address' => $address,
                        'Email' => $customer_email,
                        'Roturl' => $this->_urlInterface->getUrl("smilepaycsv/pay/paid") ,
                        'Roturl_status'=>'magento1.8.1_Ok',
                    );
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL,$url);
        curl_setopt($ch, CURLOPT_VERBOSE, 1);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
        curl_setopt($ch,CURLOPT_POSTFIELDS,http_build_query( $postdata));
       
        $resultxml=curl_exec($ch); 
        curl_close($ch);

        $smilepay_session = $this->getSession();

        if(!is_null( $resultxml) && !empty($resultxml) )
        {
            $xml = simplexml_load_string($resultxml);
            if (isset( $xml)) 
            {
                (strlen(trim($xml->PayEndDate)) >8 ) ? $xmlPayEndDate=$xml->PayEndDate : $xmlPayEndDate="" ;                  
                $result= array(
                    'Barcode1' => strval($xml->Barcode1),
                    'Barcode2' => strval($xml->Barcode2),
                    'Barcode3' => strval($xml->Barcode3),
                    'PayEndDate' =>urldecode($xmlPayEndDate),
                    'Amount' => strval($xml->Amount),
                    'Data_id'=> strval($xml->Data_id),
                    'Status'=> strval($xml->Status),
                    'Desc' => strval($xml->Desc),
                    'SmilePayNO'=> strval($xml->SmilePayNO),
                 );   
               // return $result;
              
            }
            else
            {
                    $result = array(
                        'Status' => '-1000',
                        'Desc'=>'取號失敗',    
                        'Data_id'=>$session->getLastRealOrderId(),
                    );   
  
            }
        }
        else
        {
            $result = array(
                        'Status' => '-1000',
                        'Desc'=>'取號失敗',    
                        'Data_id'=>$session->getLastRealOrderId(),
                    );   
        }
        $smilepay_session->setSmilepaycsvResult($result);

        if($result['Status']==1) // success
        {
            
            
            

            $db_insertdata=array("order_increment_id" =>    $result['Data_id'],
                                 "smse_id" => $result['SmilePayNO'],
                                 'barcode1' => $result['Barcode1'],
                                 'barcode2' => $result['Barcode2'],
                                 'barcode3' => $result['Barcode3'],
                                           );

            if(!empty($result['PayEndDate']))
            {
                $admincomment=sprintf(__('smilepay_csv_placeorder_comment_admin_success'),$result['SmilePayNO'],$paymentmethod->getTitle(),$result['Amount'],$result['PayEndDate']);
                $customercomment=sprintf(__('smilepay_csv_placeorder_comment_customer_success'),$paymentmethod->getTitle(),$result['Amount'],$result['PayEndDate']);
                $db_insertdata['dateline']=$result['PayEndDate'];
            }
            else
            {
                $admincomment=sprintf(__('smilepay_csv_placeorder_comment_admin_success_nodayline'),$result['SmilePayNO'],$paymentmethod->getTitle(),$result['Amount']);
                $customercomment=sprintf(__('smilepay_csv_placeorder_comment_customer_success_nodayline'),$paymentmethod->getTitle(),$result['Amount']);
            } 

            $db_write->insert($resource->getTableName('smilepaycsv_record'),
                                     $db_insertdata);
          //  $order->setState(\Magento\Sales\Model\Order::STATE_NEW);
            $order->addStatusHistoryComment( $admincomment,false);
           // $order->setState(Mage_Sales_Model_Order::STATE_PENDING_PAYMENT,true, $admincomment);
              // $order->addStatusHistoryComment($admincomment,Mage_Sales_Model_Order::STATE_PENDING_PAYMENT);
            //$order->setState($order->getState(),true, $customercomment,true);
            $history=$order->addStatusHistoryComment($customercomment,false);
            $history->setIsCustomerNotified(true);
            $history->setIsVisibleOnFront(1);
            
            $order->save();

            $objectManager = \Magento\Framework\App\ObjectManager::getInstance();

            $emailSender = $objectManager->create('\Magento\Sales\Model\Order\Email\Sender\OrderSender');
            $emailCommentSender = $objectManager->create('\Magento\Sales\Model\Order\Email\Sender\OrderCommentSender');
            if( $order->getCanSendNewEmailFlag())
            {
               $emailSender->send($order);
                //$order->sendNewOrderEmail();
            }
            $emailCommentSender->send($order,true, $customercomment);
        }
        else
        {
            //fail
            $admincomment=sprintf(__('smilepay_csv_placeorder_comment_admin_error'),$result['Status'],$result['Desc']);
            $customercomment=sprintf(__('smilepay_csv_placeorder_comment_customer_error'));
            //$order->setState(\Magento\Sales\Model\Order::STATE_CANCELED,true, $admincomment,true);
            $order->addStatusHistoryComment($admincomment,\Magento\Sales\Model\Order::STATE_CANCELED);
            $history=$order->addStatusHistoryComment($customercomment,false);
            $history->setIsCustomerNotified(true);
            $history->setIsVisibleOnFront(1);

            $order->save();
            $objectManager = \Magento\Framework\App\ObjectManager::getInstance();

            $emailSender = $objectManager->create('\Magento\Sales\Model\Order\Email\Sender\OrderSender');
            $emailCommentSender = $objectManager->create('\Magento\Sales\Model\Order\Email\Sender\OrderCommentSender');
            if( $order->getCanSendNewEmailFlag())
            {
                $emailSender->send($order);
                //$order->sendNewOrderEmail();
            }
            $emailCommentSender->send($order,true, $customercomment);
        }


    }
    
    function getSession()
    {
        return $this->_smilepaycsv_session;
    }

    protected function midfun($Mid_value,$Amount,$Smseid,$Mid_smilepay)
    {   
        $Amount = str_pad($Amount,8,'0',STR_PAD_LEFT);                   
        $Smseid= preg_replace('/[\D]/i','9',substr($Smseid,-4));      
        $dtotal=$Mid_value.$Amount.$Smseid;                              
      
        $i = 1;
        $sum = strlen($dtotal);
        $etemp=0;      
        while ($i <= $sum)
        {
            $ep = substr($dtotal,$i,1);
            $etemp = $etemp + $ep;                
            $i=$i+2;
        }                
      
        $i = 0;  
        $otemp=0;          
        while ($i <= $sum)
        {                                              
            $op = substr($dtotal,$i,1);
            $otemp = $otemp + $op;
            $i=$i+2;
        }
        $mid=($etemp*3)+($otemp*9);    
      
        if($Mid_smilepay == $mid){
            return true;
        }else{
            return false;
        }            
    }   	
  	


}

?>