<?php

namespace  Smilepay\Smilepaycsv\Model;


use Magento\Quote\Api\Data\CartInterface;

use Magento\Framework\DataObject;
use Magento\Payment\Model\InfoInterface;
use Magento\Payment\Model\MethodInterface;
use Magento\Payment\Observer\AbstractDataAssignObserver;
use Magento\Sales\Model\Order\Invoice;
use Magento\Sales\Model\Order\Payment;
use Magento\Quote\Api\Data\PaymentMethodInterface;


class Paymentmethod extends  \Magento\Payment\Model\Method\AbstractMethod
{
    const PAYMENT_METHOD_SMILEPAYCSV_CODE =  'smilepaycsv';
    protected $_code  = self::PAYMENT_METHOD_SMILEPAYCSV_CODE;

    /**
     * Cash On Delivery payment block paths
     *
     * @var string
     */
    protected $_formBlockType ="Smilepay\\Smilepaycsv\\Block\\Form\\Smilepaycsvcheckout";
    protected $_infoBlockType = "Smilepay\\Smilepaycsv\\Block\\Info\\Smilepaycsvcheckout";
    protected $_smilepaycsv_helper_data;
    protected $_storeManager;
    protected $_urlInterface;

    public function __construct(
        \Magento\Framework\Model\Context $context,
        \Magento\Framework\Registry $registry,
        \Magento\Framework\Api\ExtensionAttributesFactory $extensionFactory,
        \Magento\Framework\Api\AttributeValueFactory $customAttributeFactory,
        \Magento\Payment\Helper\Data $paymentData,
        \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig,
        \Magento\Payment\Model\Method\Logger $logger,
        \Smilepay\Smilepaycsv\Helper\Data   $smilepaycsv_helper_data,
        \Magento\Store\Model\StoreManagerInterface $storeManager,
        \Magento\Framework\UrlInterface $urlInterface,
        \Magento\Framework\Model\ResourceModel\AbstractResource $resource = null,
        \Magento\Framework\Data\Collection\AbstractDb $resourceCollection = null,
        array $data = []
    ) {

        parent::__construct(
            $context,
            $registry,
            $extensionFactory,
            $customAttributeFactory,
            $paymentData,
            $scopeConfig,
            $logger,
            $resource,
            $resourceCollection,
            $data
        );
        $this->_smilepaycsv_helper_data=$smilepaycsv_helper_data;
        $this->_storeManager=$storeManager;
        $this->_urlInterface = $urlInterface;
    }


    //protected $_infoBlockType = 'payment/info';
    public function getInstructions()
    {
        return trim($this->getConfigData('instructions'));
    }
    public function getDcvc()
    {
        return trim($this->getConfigData('smilepay_csv_dcvc'));
    }
    public function getVkey()
    {
        return trim($this->getConfigData('smilepay_csv_vkey'));
    }
    public function getRvg2c()
    {
        return trim($this->getConfigData('smilepay_csv_Rvg2c'));
    }
    public function getMid()
    {
        return trim($this->getConfigData('smilepay_csv_mid'));
    }
    public function getMidVal()
    {
        return trim($this->getConfigData('smilepay_csv_mid_val'));
    }
    public function getOrderPlaceRedirectUrl()
    {
        return $this->_urlInterface->getUrl('smilepaycsv/Pay/PlaceOrder', array('_secure' => false));
    }
    public function getCurrencyLimit()
    {
        return trim($this->getConfigData('smilepay_csv_currency_limit'));
    }
    public function getOrderStatus()
    {
        return trim($this->getConfigData('order_status'));
    }
    public function validate()
    {
       parent::validate();

       if( is_null($this->getDcvc()) || $this->getDcvc() == "" 
            || is_null($this->getVkey()) || $this->getVkey() == "" 
            || is_null($this->getRvg2c()) || $this->getRvg2c() == "" )
       {
           $errorCode = 'invalid_data';
           $errorMsg = __("smilepay_csv_vaildate_smse_config_error");
       }

       if (isset($errorMsg)) 
       {
           throw new \Magento\Framework\Exception\LocalizedException(
               new \Magento\Framework\Phrase($errorMsg)
            );
       }
    }

    public function isAvailable(CartInterface $quote = null)
    {
        $result=parent::isAvailable($quote );

        if( $result)
        {
            if($this->getCurrencyLimit()==true)
            {
                if($this->_storeManager->getStore()->getCurrentCurrencyCode() != 'TWD')
                    return false;
            }
        }

        return $result;

    }


    public function getBarcode1($increment_id="0")
    {
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $resource = $objectManager->create('Magento\Framework\App\ResourceConnection'); 
        $db_read= $resource->getConnection();
        $tableName = $resource->getTableName('smilepaycsv_record');
        if($db_read->isTableExists($tableName))
        {
            $results = $db_read->fetchAll("select barcode1 from $tableName where order_increment_id=" .$increment_id ." ORDER BY record_id DESC limit 1");
        }
        else
            return false;
        
        if(!empty( $results) )
            return $results[0]['barcode1'];
        else
            return false;


    }

}

?>