<?php
    
namespace Smilepay\Smilepayezcatup\Controller\Adminhtml\Order;

class Create extends \Magento\Backend\App\Action
{


    protected $_checkoutSession;
    protected $_orderFactory;
    protected $_smilepayezcatup_shippingmethod;
    protected $_smilepayezcatup_helper_data;
    protected $_resultPageFactory;
    protected $_urlInterface;
    protected $_objectManager;
    protected $_request;
    public function __construct(
        \Magento\Backend\App\Action\Context $context,
        \Magento\Framework\View\Result\PageFactory $resultPageFactory,
        \Magento\Checkout\Model\Session $checkoutSession,
        \Magento\Sales\Model\Order $orderFactory,
        \Smilepay\Smilepayezcatup\Model\Shippingmethod $smilepayezcatup_shippingmethod,
        \Smilepay\Smilepayezcatup\Helper\Data   $smilepayezcatup_helper_data
    ) {
        $this->_checkoutSession = $checkoutSession;
        $this->_orderFactory = $orderFactory;
       
        $this->_smilepayezcatup_shippingmethod = $smilepayezcatup_shippingmethod;
        $this->_smilepayezcatup_helper_data=$smilepayezcatup_helper_data;
        $this->_resultPageFactory = $resultPageFactory;
        //$this->_urlInterface = $urlInterface;
        $this->_urlInterface =$context->getUrl();
        $this->_objectManager = $context->getObjectManager();
        //$this->_objectManager = $objectManager;
        $this->_request = $context->getRequest();
       
        parent::__construct($context);
    }
    
  
    public function execute()
    {
        $resultPage = $this->_resultPageFactory->create();
        $resultPage->getConfig()->getTitle()->prepend('Smilepayezcat cerate');


         
        $request = $this->_request;
        $order_id = $request->getParam('order_id');
        $protect_code = $request->getParam('code');
        $order = $this->_orderFactory->load( $order_id );
        $Incrementid = $order->getIncrementId();

        $sp_length = $request->getParam('sp_length');
        $sp_width = $request->getParam('sp_width');
        $sp_height = $request->getParam('sp_height');
        $lwh = intval( round($sp_length + $sp_width + $sp_height));

        if(empty($Incrementid))
        {
            echo '訂單資料錯誤'; 
            return  ;
        }
        if( $protect_code != $order->getProtectCode())
        {
           echo '訂單核對錯誤'; 
           return  ;
        }
       
        $smilepayezcatup_shippingmethod = $this->_smilepayezcatup_shippingmethod;
        $result= $smilepayezcatup_shippingmethod->runezcatupProcess( $Incrementid, $lwh);

        if($result!=null)
        {
            if($result['Status'] != 1)
            {
               echo '錯誤碼:'. $result['Status'] . "<br>" . '錯誤描述:'. $result['Desc'] . "<br>";
               return;
            }
        }
       
   
       $this->_redirect('sales/order/view',array('order_id'=> $order_id));




        return $resultPage;
    }
   
  	

}

?>