<?php
namespace  Smilepay\Smilepayezcatup\Helper;
use Magento\Framework\Pricing\PriceCurrencyInterface;

class Data extends \Magento\Framework\App\Helper\AbstractHelper
{
    protected $_storeManager;
    protected $priceCurrency;
    protected $_orderFactory;
    protected $_currencyFactory;

    public function __construct(
        \Magento\Framework\App\Helper\Context $context,
        \Magento\Store\Model\StoreManagerInterface $storeManager,
        \Magento\Sales\Model\Order $orderFactory,
        \Magento\Directory\Model\Currency $currencyFactory,
        PriceCurrencyInterface $priceCurrency
    ) {
        $this->_storeManager = $storeManager;
        $this->priceCurrency = $priceCurrency;
        $this->_orderFactory = $orderFactory;
        $this->_currencyFactory= $currencyFactory;
        parent::__construct($context);
    }


    public function convertOrderTotal($order_increment_id)
    {
         $currency_mod = $this->_currencyFactory;
         $order = $this->_orderFactory;
         $order->loadByIncrementId($order_increment_id);

         $currency_codes=$currency_mod->getConfigAllowCurrencies();
         $find_TWD=false;
      
         foreach($currency_codes as $currency_code)
         {
             if($currency_code == 'TWD')
             {
                 $find_TWD =true;
           
                 break;
             }
         }
      
         if($find_TWD)
         {
            try
            {
                $currency_mod = $currency_mod->load($currency_mod->getConfigBaseCurrencies());
                $rate=$currency_mod->getCurrencyRates($currency_mod->getConfigBaseCurrencies()[0],"TWD")['TWD'];
                if(isset($rate))
                    $total = intval(round($order->getBaseGrandTotal()*$rate));
                else
                    $total = intval(round($order->getBaseGrandTotal()));
            }
            catch(Exception $e)
            {
                 $total = intval(round($order->getBaseGrandTotal()));
            }
         }
         else
            $total = intval (round($order->getBaseGrandTotal()));
         return $total;

    }
    public function convertToTWDPrice($price)
    {
         $currency_mod = $this->_currencyFactory;
         $currency_codes=$currency_mod->getConfigAllowCurrencies();
         $find_TWD=false;
         foreach($currency_codes as $currency_code)
         {
             if($currency_code == 'TWD')
             {
                 $find_TWD =true;
                 
                 break;
             }
         }

         if($find_TWD)
         {
            try
            {
                $currency_mod = $currency_mod->load($currency_mod->getConfigBaseCurrencies());
                $rate=$currency_mod->getCurrencyRates($currency_mod->getConfigBaseCurrencies()[0],"TWD")['TWD'];
                if(isset($rate))
                    $total = intval(round($price*$rate));
                else
                    $total = intval(round($price));
        
            }
            catch(Exception $e)
            {
                 $total = intval (round($order->getBaseGrandTotal()));
            }
         }
            
         else
            $total = intval (round($price));

         return $total;

    }

    public function convertToTWDPriceNotRound($price)
    {
         $currency_mod = $this->_currencyFactory;

         $currency_codes=$currency_mod->getConfigAllowCurrencies();
         $find_TWD=false;
         foreach($currency_codes as $currency_code)
         {
             if($currency_code == 'TWD')
             {
                 $find_TWD =true;
                 
                 break;
             }
         }

         if($find_TWD)
         {
            try
            {
                $currency_mod = $currency_mod->load($currency_mod->getConfigBaseCurrencies());
                $rate=$currency_mod->getCurrencyRates($currency_mod->getConfigBaseCurrencies()[0],"TWD")['TWD'];
               if(isset($rate))
                    $total = $price*$rate;
                else
                    $total = $price;
             
            }
            catch(Exception $e)
            {
                 $total = $price;
            }
         }
         else
            $total = $price;

         return $total;

    }  
    public function findTWD()
    {
        $currency_mod = $this->_currencyFactory;
        $currency_codes=$currency_mod->getConfigAllowCurrencies();
        $find_TWD=false;
        foreach($currency_codes as $currency_code)
        {
             if($currency_code == 'TWD')
             {
                 $find_TWD =true;
                 break;
             }
        }
        if($find_TWD)
        {
            try
            {
               $currency_mod = $currency_mod->load($currency_mod->getConfigBaseCurrencies());
               $rate=$currency_mod->getCurrencyRates($currency_mod->getConfigBaseCurrencies()[0],"TWD")['TWD'];
               if(isset($rate))
                 return true;
             
            }
            catch(Exception $e)
            {
                
            }
        }

        return false;
    }
    function isCurrencyTWDselected()
    {
        if(  $this->_storeManager->getStore()->getCurrentCurrencyCode() == 'TWD')
            return true;
        else
            return false;
    }
}
?>