<?php
namespace Smilepay\Smilepayezcatup\Setup;

class InstallSchema implements \Magento\Framework\Setup\InstallSchemaInterface
{
    public function install(\Magento\Framework\Setup\SchemaSetupInterface $setup, \Magento\Framework\Setup\ModuleContextInterface $context)
    {
        $installer = $setup;
        $installer->startSetup();
        $tableName = $installer->getTable('smilepayezcatup_record');
        if ($installer->getConnection()->isTableExists($tableName) != true) {
                $table = $installer->getConnection()->newTable($tableName)
                   ->addColumn('record_id',  \Magento\Framework\DB\Ddl\Table::TYPE_INTEGER, null, array(
                                            'identity'  => true,
                                            'unsigned'  => true,
                                            'nullable'  => false,
                                            'primary'   => true,
                                            ), 'smilepayezcatup record id')
                   ->addColumn('order_increment_id',  \Magento\Framework\DB\Ddl\Table::TYPE_TEXT, 50, array(
                                            ), 'order_increment_id')
                   ->addColumn('smse_id',  \Magento\Framework\DB\Ddl\Table::TYPE_TEXT, 50, array(
                                            ), 'smse_id')
                   ->addColumn('tracknum',  \Magento\Framework\DB\Ddl\Table::TYPE_TEXT, 512, array(
                                            ), 'tracknum')
                   ->setComment('SmilePay ezcatup Record');

                    $installer->getConnection()->createTable($table);

        }
       
        $installer->endSetup();
    }
}