<?php
namespace Smilepay\Smilepayibon\Observer;

use Magento\Framework\Event\ObserverInterface;
    use Magento\Framework\DataObject;
use Magento\Payment\Model\InfoInterface;
use Magento\Payment\Model\MethodInterface;
use Magento\Payment\Observer\AbstractDataAssignObserver;
use Magento\Sales\Model\Order\Invoice;
use Magento\Sales\Model\Order\Payment;
use Magento\Quote\Api\Data\PaymentMethodInterface;


class PlaceOrderSuccess  implements ObserverInterface
{
    protected $_storeManager;
    protected $_orderFactory;
    protected $_smilepayibon_session;
    protected $_smilepayibon_paymentmethod;
    protected $_smilepayibon_helper_data;
    protected $_context;
    public function __construct(
        \Magento\Framework\App\Action\Context $context,
        \Magento\Sales\Model\Order $orderFactory,
        \Smilepay\Smilepayibon\Model\Session $smilepayibon_session,
        \Smilepay\Smilepayibon\Model\Paymentmethod $smilepayibon_paymentmethod,
        \Magento\Store\Model\StoreManagerInterface $storeManager,
        \Smilepay\Smilepayibon\Helper\Data   $smilepayibon_helper_data)
    {
        $this->_storeManager = $storeManager;
        $this->_orderFactory = $orderFactory;
        $this->_smilepayibon_session = $smilepayibon_session;
        $this->_smilepayibon_paymentmethod = $smilepayibon_paymentmethod;
        $this->_smilepayibon_helper_data=$smilepayibon_helper_data;
        $this->_context =$context;
    }

  //generate order info to checkout success
  public function execute(\Magento\Framework\Event\Observer $observer)
  {
      $event = $observer->getEvent();
    
      $order_id = $event->getOrderIds()[0];

      if(!isset($order_id) || empty($order_id))
          return;
      $order =$this->_orderFactory;
      $order->load($order_id);

      $paymentmethod = $order->getPayment()->getMethod();

      if( trim($paymentmethod) == 'smilepayibon')
      {
          $controlleraction = $this->_context->getView();


          /*$block = $controlleraction->getLayout()->createBlock('Magento\Framework\View\Element\Template','smilepayibon_message',
                                                                                                                        array('data'=> 
                                                                                                                                array('template' => 'Smilepay_Smilepayibon::placeorder/success.phtml')
                                                                                                                         ));*/

          //$block =$controlleraction->getLayout()->addBlock('Magento\Framework\View\Element\Template','smilepayibon_message','order.success.additional.info');  
          $block =$controlleraction->getLayout()->addBlock('Magento\Framework\View\Element\Template','smilepayibon_message','content');  
          $block->setTemplate('Smilepay_Smilepayibon::placeorder/success.phtml');
          $session= $this->_smilepayibon_session;
          $smilepayibon_result=$session->getSmilepayibonResult();
          $smilepayibon_model= $this->_smilepayibon_paymentmethod;


       

          $block->assign(
                        array(
                            'smilepay_ibon_title' =>   $smilepayibon_model->getTitle(),
                            'smilepay_ibon_status' =>  $smilepayibon_result['Status'],
                            'smilepay_ibon_ibon_no' =>$smilepayibon_result['IbonNo'],
                            'smilepay_ibon_amount' => $smilepayibon_result['Amount'],
                            'smilepay_ibon_dateline' => $smilepayibon_result['PayEndDate'],
                             )
                    );
          $session->clearStorage();
     
          $controlleraction->getLayout()->reorderChild("content",'smilepayibon_message','checkout.success',false);

      
      //    $controlleraction->getLayout()->getBlock('checkout.success')->insert($block,'',false);
     
      }
    
  }
}


?>