<?php
namespace  Smilepay\Smilepaypalmboxc2cup\Model;
use Magento\Quote\Model\Quote\Address\RateRequest;
use Magento\Shipping\Model\Carrier\AbstractCarrier;
use Magento\Shipping\Model\Carrier\CarrierInterface;
use Magento\Shipping\Model\Rate\Result;
use Magento\Sales\Model\Order\ShipmentFactory;

class Shippingmethod
extends \Magento\Shipping\Model\Carrier\AbstractCarrier
implements \Magento\Shipping\Model\Carrier\CarrierInterface
{
  protected $_code = 'smilepaypalmboxc2cup';
  protected $smseurl = 'https://ssl.smse.com.tw/api/sppayment.asp';
  protected $smse_palmboxc2cup_url = 'https://ssl.smse.com.tw/api/pbGetCheckCode.asp';
  protected $table_fields = array('order_increment_id','smse_id','tracknum','checkcode','cvsstoredata');
  protected $table_id_field = 'order_increment_id';

  const METHOD_NORMAL = 'normal';
  protected $service_name = array(
                            self::METHOD_NORMAL,
                            /*'fridge',
                            'freeze'*/
                        );
  protected $temperature_id = array(
                            self::METHOD_NORMAL => '0',
                            /*'fridge' => '0002',
                            'freeze' => '0003'*/
                        );
  protected $service_support_package = array(
                            self::METHOD_NORMAL=>array('1','2','3')
                            /*'fridge'=>120,
                            'freeze'=>120*/
                        );

  private static $map_url = array(  
                                    self::METHOD_NORMAL=>  array(
                                                 'mobile'=>'https://ssl.smse.com.tw/api/LogisticsEmap.asp?TypesServer=PALMBOXC2C&TypesInterface=WEB&tempvar=%s&url=%s',
                                                 'normal'=>'https://ssl.smse.com.tw/api/LogisticsEmap.asp?TypesServer=PALMBOXC2C&TypesInterface=WEB&tempvar=%s&url=%s'
                                                 ),
                                );
  protected $serivce_config = array(
                                self::METHOD_NORMAL=>array(
                                            'field_method_id'=> self::METHOD_NORMAL,
                                            'field_active' =>'normal_active',
                                            'field_price'=> 'normal_price',
                                            'field_name'=> 'normal_name',
                                            'ret_controller'=>'saveEmap',
                                           // 'pay_subzg'=>'7NET',
                                            'csvTypeName'=> self::METHOD_NORMAL
                                        ),
                              );
  protected $_isFixed = true;  
  protected $_rateResultFactory;
  protected $_rateMethodFactory;
  protected $_storeManager;
  protected $_urlInterface;
  protected  $_smilepaypalmboxc2cup_session;
  protected $_orderFactory;
  protected $_smilepaypalmboxc2cup_helper_data;
  protected $_action_context;
  protected $_shipmentFactory;
  protected $_trackFactory;
  protected $_trackErrorFactory;
  protected $_trackStatusFactory;
  protected $generatorPool;

  protected $_checkout_session;
  protected $model_quote;

  public function __construct(
        \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig,
        \Magento\Quote\Model\Quote\Address\RateResult\ErrorFactory $rateErrorFactory,
        \Psr\Log\LoggerInterface $logger,
        \Magento\Shipping\Model\Rate\ResultFactory $rateResultFactory,
        \Magento\Store\Model\StoreManagerInterface $storeManager,
        \Magento\Sales\Model\Order $orderFactory,
        \Magento\Quote\Model\Quote\Address\RateResult\MethodFactory $rateMethodFactory,
        \Smilepay\Smilepaypalmboxc2cup\Model\Session $smilepaypalmboxc2cup_session,
        \Smilepay\Smilepaypalmboxc2cup\Helper\Data   $smilepaypalmboxc2cup_helper_data,
        \Magento\Framework\View\Layout\GeneratorPool  $generatorPool,
        \Magento\Sales\Model\Order\ShipmentFactory $shipmentFactory,
        \Magento\Shipping\Model\Tracking\ResultFactory $trackFactory,
        \Magento\Shipping\Model\Tracking\Result\ErrorFactory $trackErrorFactory,
        \Magento\Shipping\Model\Tracking\Result\StatusFactory $trackStatusFactory,
        \Magento\Framework\App\Action\Context $action_context,
        \Magento\Checkout\Model\Session $checkoutSession,
        \Magento\Quote\Model\Quote $model_quote,
        array $data = []
    ) {
        $this->_rateResultFactory = $rateResultFactory;
        $this->_rateMethodFactory = $rateMethodFactory;
        $this->_storeManager=$storeManager;
       // $this->_urlInterface = $urlInterface;
        $this->_smilepaypalmboxc2cup_session = $smilepaypalmboxc2cup_session;
        $this->_orderFactory = $orderFactory;
        $this->_smilepaypalmboxc2cup_helper_data =  $smilepaypalmboxc2cup_helper_data;
        $this->_action_context = $action_context;
        $this->_urlInterface =  $this->_action_context->getUrl();
        $this->_shipmentFactory = $shipmentFactory;
        $this->_trackFactory = $trackFactory;
        $this->_trackErrorFactory = $trackErrorFactory;
        $this->_trackStatusFactory = $trackStatusFactory;

        $this->generatorPool = $generatorPool;
        $this->_checkout_session = $checkoutSession;
        $this->_model_quote = $model_quote;

        parent::__construct($scopeConfig, $rateErrorFactory, $logger, $data);

   }





  public function getMaxOrderTotal()
  {
    return $this->getConfigData('max_order_total');
  }
  public function getMinOrderTotal()
  {
    return $this->getConfigData('min_order_total');
  }

  public function getCurrencyLimit()
  {
    return trim($this->getConfigData('smilepay_palmboxc2cup_currency_limit'));
  }
  public function isActive()
  {
    $result=parent::isActive();
    if( $result)
    {
        if($this->getCurrencyLimit()==true)
        {
            if($this->_storeManager->getStore()->getCurrentCurrencyCode() != 'TWD')
                return false;
        }

    }
    return $result;
  }
  
  public function collectRates(RateRequest $request)
  {
    if (!$this->isActive()) 
    {
            return false;
    }
    //check total
  
    $minTotal = $this->getConfigData('min_order_total');
    $maxTotal = $this->getConfigData('max_order_total');
   

    $result = $this->_rateResultFactory->create();

    $this->_updateFreeMethodQuote($request);


    foreach($this->service_name as $service_id)
    {
        $total = $request->getBaseSubtotalInclTax()+$this->getConfigData( $service_id.'_price');
        
        if ((!empty($minTotal) && ($total < $minTotal)) || (!empty($maxTotal) && ($total > $maxTotal))) {
               continue;
        }    
        $result->append($this->_getDefaultRate($request,$service_id));
       
    }
 
    return $result;
  }
 
  public function getAllowedMethods()
  {
    $method = array();
    foreach($this->service_name as $service_id)
    {
         $method[$service_id] =$this->getConfigData($service_id.'_name');
    }

    return $method;
  }
  
  protected function _getDefaultRate($request,$service_id)
  {
    if(!$this->getConfigData($service_id. '_active'))
          return null;
    $rate = $this->_rateMethodFactory->create();
    
    $rate->setCarrier($this->_code);
    $rate->setCarrierTitle($this->getConfigData('title'));
    $rate->setMethod($service_id);
    $rate->setMethodTitle($this->getConfigData($service_id.'_name'));
    $rate->setPrice($this->getConfigData($service_id.'_price'));
    $rate->setCost(0);

    //free cost over specfic total
    if ($request->getFreeShipping() 
            ||( $this->getConfigData('free_shipping_enable') == 1 
            && !is_null( $this->getConfigData('free_shipping_subtotal'))
            && !empty($this->getConfigData('free_shipping_subtotal'))
            && $request->getBaseSubtotalInclTax() >= $this->getConfigData('free_shipping_subtotal'))
       )
    {
        $rate->setCost(0);
        $rate->setPrice(0.00);
    }

    return $rate;
  }

  public function getTitle()
  {
    return $this->getConfigData('title');
  }
  public function getName()
  {
    return  $this->getConfigData('name');
  }
  // E-Map URL
 
  public function getDcvc()
  {
    return trim($this->getConfigData('smilepay_palmboxc2cup_dcvc'));
  }
  public function getVkey()
  {
    return trim($this->getConfigData('smilepay_palmboxc2cup_vkey'));
  }
  public function getRvg2c()
  {
    return trim($this->getConfigData('smilepay_palmboxc2cup_Rvg2c'));
  }

 

  public function validate()
  {
       //parent::validate();

       $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
       $session  =  $objectManager->create('\Magento\Checkout\Model\Session');

       $quote_id = $session->getQuoteId();
       $quote = $objectManager->create('\Magento\Quote\Model\Quote');
       $quote->load($quote_id );

       $shippingaddress = $quote->getShippingAddress();

       $name = $shippingaddress->getLastname() . $shippingaddress->getFirstname();
       $telephone = $shippingaddress->getTelephone();
       if( is_null($this->getDcvc()) || $this->getDcvc() == "" 
            || is_null($this->getVkey()) || $this->getVkey() == "" 
            || is_null($this->getRvg2c()) || $this->getRvg2c() == "" )
       {
           $errorCode = 'invalid_data';
           $errorMsg = __("smilepay_palmboxc2cup_vaildate_smse_config_error");
       }


       /*if( !preg_match("/[^a-zA-Z0-9 ]/",$name))
       {
           $limit_name_number =10;
       }
       else
       {
           $limit_name_number =5;
       }

       

       if(mb_strlen($name,"utf-8") > $limit_name_number )
       {
           $errorCode = 'invalid_data';
           $errorMsg = __("smilepay_palmboxc2cup_validate_name_error");
       }   */
       elseif( !preg_match("/^[0][9][0-9]{8,8}\$/", $telephone ))
       {
           $errorCode = 'invalid_data';
           $errorMsg = __("smilepay_palmboxc2cup_validate_phone_error");
       }
       elseif(!$this->isEmapSelected())
       {
           $errorMsg = __("smilepay_palmboxc2cup_vaildate_emap_selected_error");
       }
    
     
       
       if ($errorMsg) 
            return $errorMsg;
       else
            return true;
  }

  //Description: Connect to SMSe create palmboxc2cup order
  //return: SMSe result array return when success,
  //return: error array when fail,

  public function runpalmboxc2cupProcess($order_increment_id,$lwh)
  {
      if(!isset($order_increment_id))
      {
          $error['Status']='-1';
          $error['Desc']='Error Order id, input error!';
          return $error;
      }
      $order_id=$order_increment_id;

      $order= $this->_orderFactory->loadByIncrementId($order_id);
      if (!$order->getId()) 
      {
          $error['Status']='-2';
          $error['Desc']='Error Order id, NOT find!';
          return $error;
      }
      

      $order_result = $this->createOrderProcess($order_increment_id);

      if($order_result !=null)
      {
          if($order_result['Status']!=1)
          {
              $order_result['Desc'] = 'Process => order create<br>' .  $order_result['Desc'];
              return $order_result;
          }
         
      }



      $track_result = $this->createTracknumProcess($order_increment_id,$lwh);
      if($track_result !=null)
      {
          if($track_result['Status']!=1)
          {
              $track_result['Desc'] = 'Process => Tracknum create<br>' .  $track_result['Desc'];
              return $track_result;
          }
         
      }
      return false;
  }

  public function createOrderProcess($order_increment_id)
  {
      if(!isset($order_increment_id))
      {
          $error['Status']='-1';
          $error['Desc']='Error Order id, input error!';
          return $error;
      }
      
      $order_id=$order_increment_id;

      $order= $this->_orderFactory->loadByIncrementId($order_id);

      if (!$order->getId()) 
      {
          $error['Status']='-2';
          $error['Desc']='Error Order id, NOT find!';
          return $error;
      }
 
      $customer_name =  $order->getShippingAddress()->getLastname() . $order->getShippingAddress()->getFirstname();
      $customer_email=$order->getCustomerEmail();
      $phone = $order->getShippingAddress()->getTelephone();
      //$shippingAddress=$order->getShippingAddress();
     // $address =  $shippingAddress->getData('region') . " " . $shippingAddress->getData('city') ." " .  $shippingAddress->getData('street');
     // $address =   $shippingAddress->getData('city') ." " .  $shippingAddress->getData('street');
      $method_code =  $order->getShippingMethod();

      $method_arr = explode('_', $method_code);
      if(count($method_arr) > 1)
      {
          if($method_arr[0] != $this->_code)
          {
              $error['Status']='-10002';
              $error['Desc']='Error shipping method';
              return $error;
          }


      }
        
      $temperature = $this->temperature_id[$method_arr[1]];


      $saved_data=$this->getpalmboxc2cupData($order_increment_id);

      if(!empty(  $saved_data))
      {
          foreach($saved_data as $data)
          {
              if(!empty( $data['smse_id']))
                return null;
          }
      }
      foreach($saved_data as $data)
      {
        $cvsstoredata =   $data['cvsstoredata'];
      }
      $cvsstoredata_arr= explode('/', $cvsstoredata);
      if(count( $cvsstoredata_arr)!=3)
      {
          $error['Status']='-10007';
          $error['Desc']='Error CSV Store Data';
          return $error;
      }

      
      if($this->getCurrencyLimit()==true)
      {
          $total = $order->getGrandTotal();
      }
      else
      {
           
           //find TWD selected?
          if($this->_smilepaypalmboxc2cup_helper_data->isCurrencyTWDselected())
              $total = $order->getGrandTotal();
          else
              $total = $order->getBaseGrandTotal();
      }

      $postdata = array(
                        'Dcvc' =>trim( $this->getDcvc()),
                        'Rvg2c' => trim($this->getRvg2c()),
                        'Verify_key' =>trim($this->getVkey()),
                        'Od_sob' => $order_id,
                        'Pay_zg' => 52,
                        'Pay_subzg'=> 'PBOX',
                        'Data_id' => $order_id,
                        'Amount' => intval(round($total)),
                        'Pur_name' => $customer_name,
                        'Tel_number' =>  $phone,
                        'Mobile_number' => $phone,
                       // 'Address' => $address,
                        'Email' => $customer_email,
                        'Logistics_store' => $cvsstoredata,
                        'Temperature' => $temperature
                       // 'Roturl' => Mage::getUrl("smilepaypalmboxc2cup/smilepaypalmboxc2cup/paid") ,
                        //'MapRoturl' =>Mage::getUrl("smilepaypalmboxc2cup/smilepaypalmboxc2cup/mapreturn") ,
                        //'Roturl_status'=>'magento1.8.1_Ok',
                    );
       
        //connection start
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL,$this->smseurl);
        curl_setopt($ch, CURLOPT_VERBOSE, 1);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
        curl_setopt($ch,CURLOPT_POSTFIELDS,http_build_query( $postdata));
       
        $resultxml=curl_exec($ch); 
        curl_close($ch);
         

        if(!is_null( $resultxml) && !empty($resultxml) )
        {
            $xml = simplexml_load_string($resultxml);
            if (isset( $xml)) 
            {
                //(strlen(trim($xml->PayEndDate)) >8 ) ? $xmlPayEndDate=$xml->PayEndDate : $xmlPayEndDate="" ;                  
                $result= array(
                    //'PayEndDate' =>urldecode($xmlPayEndDate),
                    'Amount' => strval($xml->Amount),
                    'Data_id'=> strval($xml->Data_id),
                    'Status'=> strval($xml->Status),
                    'Desc' => strval($xml->Desc),
                    'SmilePayNO'=> strval($xml->SmilePayNO),
                 );   
    
            }
            else
            {
                 $result = array(
                            'Status' => '-1000',
                            'Desc' => '取號失敗',    
                            'Data_id'=>$order_id,
                        );     
            }
        }
        else
        {
            $result = array(
                        'Status' => '-1000',
                        'Desc'=>'取號失敗',    
                        'Data_id'=>$order_id,
                    );     
        }
        
        $Smseid = $result['SmilePayNO'];
    
        if($result['Status']==1) // success
        {
         
            
           $admincomment=sprintf(__('smilepay_palmboxc2cup_placeorder_comment_admin_success'),$Smseid );
            //note
            $order->addStatusHistoryComment( $admincomment,false);
            /*$history=$order->addStatusHistoryComment($customercomment,false);
            $history->setIsCustomerNotified(true);
            $history->setIsVisibleOnFront(1);*/

            $order->save();
           // $order->sendOrderUpdateEmail(true, $customercomment);

            $add_data= array("order_increment_id" =>  $result['Data_id'],
                                           "smse_id" => $Smseid,
                                           );
                                           
            $this->savepalmboxc2cupData($result['Data_id'],$add_data);

        }

        return $result;
   }

   public function createTracknumProcess($order_increment_id,$boxsize)
   {
      if(empty($order_increment_id))
      {
          $error['Status']='-1';
          $error['Desc']='Error Order id, input error!';
          return $error;
      }
      
      $order_id=$order_increment_id;
      $order= $this->_orderFactory->loadByIncrementId($order_id);
 

      if (!$order->getId()) 
      {
          $error['Status']='-2';
          $error['Desc']='Error Order id, NOT find!';
          return $error;
      }

      $method_code =  $order->getShippingMethod();

      $method_arr = explode('_', $method_code);
       
      if(!in_array($boxsize,$this->service_support_package[$method_arr[1]]))
      {
           $error['Status']='-10011';
          $error['Desc']='Error box SIZE(Over Max Value of service.)';
          return $error;
      }
      
      if(count($method_arr) > 1)
      {
          if($method_arr[0] != $this->_code)
          {
              $error['Status']='-10002';
              $error['Desc']='Error shipping method';
              return $error;
          }

      }

      $saved_data=$this->getpalmboxc2cupData($order_increment_id);
  
      if(!empty(  $saved_data))
      {
          foreach($saved_data as $data)
          {
              if(empty( $data['smse_id']))
              {
                  $error['Status']='-10009';
                  $error['Desc']='Error!! smse_id DOES NOT exist.';
                  return $error;
                
              }
              elseif(!empty($data['track_num']))
                return NULL;
              $smseid=$data['smse_id'];
              break;
          }
      }
      else
      {
           $error['Status']='-10010';
           $error['Desc']='Error!! smse_id and order DOES NOT created.';
           return $error;
      }


      $postdata = array(
                        'Dcvc' =>trim( $this->getDcvc()),
                        'Rvg2c' => trim($this->getRvg2c()),
                        'Verify_key' =>trim($this->getVkey()),                  
                    );
      $postdata['smseid'] = $smseid;
      $postdata['Package_size'] = $boxsize;
        //connection start
      $ch = curl_init();
      curl_setopt($ch, CURLOPT_URL,$this->smse_palmboxc2cup_url);
      curl_setopt($ch, CURLOPT_VERBOSE, 1);
      curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
      curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
      curl_setopt($ch, CURLOPT_POST, 1);
      curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
      curl_setopt($ch,CURLOPT_POSTFIELDS,http_build_query( $postdata));
       
      $resultxml=curl_exec($ch); 
      curl_close($ch);


      if(!is_null( $resultxml) && !empty($resultxml) )
      {
            $xml = simplexml_load_string($resultxml);
            if (isset( $xml)) 
            {
                //(strlen(trim($xml->PayEndDate)) >8 ) ? $xmlPayEndDate=$xml->PayEndDate : $xmlPayEndDate="" ;                  
                $result= array(
                    //'PayEndDate' =>urldecode($xmlPayEndDate),
                    'CheckCode' => strval($xml->CheckCode),
                    'Amount' => strval($xml->Amount),
                    'Data_id' => strval($xml->Data_id),
                    'Status' =>strval($xml->Status),
                    'Desc' =>strval($xml->Desc)
                 );   
    
            }
            else
            {
                 $result = array(
                            'Status' => '-1000',
                            'Desc' => '取號失敗',    
                            'Data_id'=>$order_id,
                        );     
            }
      }
      else
      {
            $result = array(
                        'Status' => '-1000',
                        'Desc'=>'取號失敗',    
                        'Data_id'=>$order_id,
                    );     
      }
        
      if($result['Status']==1) // success
      {
        
           $admincomment=sprintf(__('smilepay_palmboxc2cup_createtracknum_comment_admin_success'),$result['CheckCode'] );
            //note
            //$order->addStatusHistoryComment( $admincomment,false);
            $history=$order->addStatusHistoryComment($admincomment,false);
            $history->setIsCustomerNotified(true);
            $history->setIsVisibleOnFront(1);

           // $order->save();
           /* $order->sendOrderUpdateEmail(true, $customercomment);*/
           // $order->save();
            $add_data= array("order_increment_id" =>  $order_increment_id,
                                            "checkcode" =>$result['CheckCode']
                                           );
            $this->savepalmboxc2cupData( $order_increment_id,$add_data);
            /*$tracking = array(
                            array(
                                'title'=>$this->getConfigData('title'),
                                'carrier_code' =>$this->_code,
                                'number' =>$result['TrackNum']
                            )
                            
                        );
            $shipment = $this->_shipmentFactory->create($order,[], $tracking);
            
            $shipment->save();
            */

            /*$shipment = Mage::getModel('sales/service_order', $order)->prepareShipment();
            if ($shipment) {
                $track = Mage::getModel('sales/order_shipment_track')
                    ->setNumber($result['TrackNum'])
                    ->setCarrierCode($this->_code)
                    ->setTitle($this->getConfigData('title'));
                $shipment->addTrack($track)
                    ->save();
          }*/
            
      }

      return $result;
   }

   public function savepalmboxc2cupData($order_increment_id,$data)
   {
      if(empty($order_increment_id))
        return NULL;
      if(!is_array($data))
        return NULL;
      if(!isset($data[$this->table_id_field]))
      {
          $data[$this->table_id_field] = $order_increment_id;
      }
      foreach($data as $key=>$val)
      {
         if(!in_array($key,$this->table_fields))
         {
             unset($data[$key]);
         }
      }
      $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
      $resource = $objectManager->create('Magento\Framework\App\ResourceConnection');
            
      $db_write= $resource->getConnection();

      $read_result = $db_write->fetchOne("select * from `". $resource->getTableName('smilepaypalmboxc2cup_record'). "` where `order_increment_id` = " . $order_increment_id);
      
      if(empty($read_result))
      {
        $db_write->insert($resource->getTableName('smilepaypalmboxc2cup_record'),
                                     $data
                            );
      }
      else
      {
        $whereCondition = array($this->table_id_field . '=?' => $data[$this->table_id_field]);
        $db_write->update($resource->getTableName('smilepaypalmboxc2cup_record'),
                                     $data,$whereCondition
                            );
      }
      $db_write->closeConnection();
      
      return TRUE;
      
  }

  public function getpalmboxc2cupData($order_increment_id)
  {
      if(empty($order_increment_id))
        return NULL;
     
      $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
      $resource = $objectManager->create('Magento\Framework\App\ResourceConnection');
      $db_read= $resource->getConnection();

      $read_result = $db_read->fetchAll("select * from `".$resource->getTableName('smilepaypalmboxc2cup_record'). "` where `order_increment_id` = " . $order_increment_id);
        
      $db_read->closeConnection();
      return $read_result;

      
  }

  public function isTrackingAvailable()
  {
        return true;
  }

  public function getTracking($trackings)
  {
    $result=$this->_trackFactory->create();
    $tracking = $this->_trackStatusFactory->create();
    $tracking->setCarrier($this->_code);
    $tracking->setCarrierTitle($this->getConfigData('title'));
    $tracking->setTracking($trackings);
    $tracking->setTrackSummary( __('NOT support this tracking function'));
    
    $result->append($tracking);

         
       
      
    return $result;
  }
  public function getTrackingInfo($tracking)
  {
        $result = $this->getTracking($tracking);

        if ($result instanceof \Magento\Shipping\Model\Tracking\Result) {
            $trackings = $result->getAllTrackings();
            if ($trackings) {
                return $trackings[0];
            }
        } elseif (is_string($result) && !empty($result)) {
            return $result;
        }

        return false;
  }


  // E-Map URL
  public function getEMapUrl($service_id='')
  {
      //map mobile start
     $useragent=$_SERVER['HTTP_USER_AGENT'];
     $isMobile=false;
     if( strpos( $useragent,'Android') === false && strpos($useragent,'iPad' ) === false && strpos( $useragent,'iPhone') === false
	        || strpos( $useragent,'Safari') === false && strpos( $useragent,'AppleWebKit') === false  && strpos( $useragent,'Dalvik') === false )
     {
        //pc
        $isMobile=false;
     }
     else
     {
        $isMobile=true;
     }
     //map mobile end
     if($isMobile)
        $emap_url = self::$map_url[$service_id]['mobile'];
     else
        $emap_url = self::$map_url[$service_id]['normal'];
    return sprintf( $emap_url,'', urlencode($this->_urlInterface->getBaseUrl()."smilepaypalmboxc2cup/emap/".$this->serivce_config[$service_id]['ret_controller']));
  }
  public function getpalmboxc2cupStoreData()
  {
      $session= $this->_smilepaypalmboxc2cup_session;

      return $session->getSmilepaypalmboxc2cupMapResult();

  }
  public function getpalmboxc2cupStoreAddress()
  {
     
      $result = $this->getpalmboxc2cupStoreData();
      return  $result['Storeaddress'];
  }
  public function getpalmboxc2cupStoreId()
  {
      $result = $this->getpalmboxc2cupStoreData();
      return  $result['Storeid'];
  }
  public function getpalmboxc2cupStoreName()
  {
      $result = $this->getpalmboxc2cupStoreData();
      return  $result['Storename'];
  }
  public function getpalmboxc2cupCVSType()
  {
      $result = $this->getpalmboxc2cupStoreData();
      return  $result['CVSType'];
  }
  //E-Map selected
  public function isEmapSelected()
  {
      $result = $this->getpalmboxc2cupStoreData();
      $selected = true;
      $csvtype='';
      
      $session = $this->_checkout_session;
      $quote_id = $session->getQuoteId();
      $quote =$this->_model_quote->load( $quote_id);
      $shippingAddr = $quote->getShippingAddress();
      $shippingMethod = $shippingAddr->getShippingMethod();
      foreach($this->serivce_config as $service_id => $serivce)
      {
          if( $shippingMethod== $this->_code."_".$serivce['field_method_id'])
          {
            $csvtype= $service_id;
            break;
          }
      }
      if(!isset($result) || empty($result))
        $selected = false;
      else
      {
          foreach($result as $storeData)
          {
            if(!isset($storeData) || empty( $storeData))
            {
              $selected = false;
              break;
            }
          }
          if( $result['CVSType'] !=  $csvtype)
            $selected = false;
      }
     
      return  $selected;
  }
  public function isEmapSelectedAny()
  {
      $result = $this->getpalmboxc2cupStoreData();
      $selected = true;
      

      
      if(!isset($result) || empty($result))
        $selected = false;
      else
      {
          foreach($result as $storeData)
          {
            if(!isset($storeData) || empty( $storeData))
            {
              $selected = false;
              break;
            }
          }
        
      }

      return  $selected;
  }
  public function isEmapSelectedByIncrementId($increment_id=0)
  {
      $result = $this->getpalmboxc2cupStoreData();
      $selected = true;

      $session  = $this->_checkout_session;
      $quote_id = $session->getQuoteId();
     
      $order= $this->_orderFactory->loadByIncrementId($increment_id);
      $csvtype='';
    
      $shippingMethod = $order->getShippingMethod();
      foreach($this->serivce_config as $service_id => $serivce)
      {
          if( $shippingMethod== $this->_code."_".$serivce['field_method_id'])
          {
            $csvtype= $service_id;
            break;
          }
      }

      if(!isset($result) || empty($result))
        $selected = false;
      else
      {
          foreach($result as $storeData)
          {
            if(!isset($storeData) || empty( $storeData))
            {
              $selected = false;
              break;
            }
          }
          if( $result['CVSType'] !=  $csvtype)
            $selected = false;
      }
     
      return  $selected;
  }

  //Description: Generate palmboxc2cup Order Block that show order result.
  //input smsedata: the data is got from  runpalmboxc2cupProcess or  runpalmboxc2cupProcessAndClear. 
  //                If it is null, it will get data from session 
  //return: block data
  public function generatepalmboxc2cupOrderBlock($smsedata)
  {
        $controlleraction =$this->_action_context->getView();
          //run process

        $blockGenerator = $this->generatorPool->getGenerator(\Magento\Framework\View\Layout\Generator\Block::TYPE);
        $block = $blockGenerator->createBlock('Magento\Framework\View\Element\Template','smilepaypalmboxc2cup_message');
      
        //$block =$controlleraction->getLayout()->addBlock('Magento\Framework\View\Element\Template','smilepaypalmboxc2cup_message');  
        $block->setTemplate('Smilepay_Smilepaypalmboxc2cup::placeorder/success.phtml');
        $session= $this->_smilepaypalmboxc2cup_session;

        $smilepaypalmboxc2cup_result=$smsedata;        
        $storedata_arr= explode( '/', $smilepaypalmboxc2cup_result['cvsstoredata']); 
        if(count($storedata_arr)==3)
        {
            $smilepaypalmboxc2cup_result['Storeid']=$storedata_arr[0];
            $smilepaypalmboxc2cup_result['Storename']=$storedata_arr[1];
            $smilepaypalmboxc2cup_result['Storeaddress']=$storedata_arr[2];
        }
        else
        {
            $smilepaypalmboxc2cup_result['Storeid']='';
            $smilepaypalmboxc2cup_result['Storename']='';
            $smilepaypalmboxc2cup_result['Storeaddress']='';
        }


        $block->assign(
                    array(
                        'smilepay_palmboxc2cup_title' =>   $this->getTitle(),
                        //'smilepay_palmboxc2cup_status' =>  $smilepaypalmboxc2cup_result['Status'],
                        'smilepay_palmboxc2cup_storename' =>$smilepaypalmboxc2cup_result['Storename'],
                        'smilepay_palmboxc2cup_storeaddress' => $smilepaypalmboxc2cup_result['Storeaddress'],
                        //'smilepay_palmboxc2cup_amount' => $smilepaypalmboxc2cup_result['Amount'],
                        'smilepay_palmboxc2cup_storeid' => $smilepaypalmboxc2cup_result['Storeid'],
                        //'smilepay_palmboxc2cup_pur_name' => $smilepaypalmboxc2cup_result['Pur_name'],
                        //'smilepay_palmboxc2cup_data_id' => $smilepaypalmboxc2cup_result['Data_id'],
                        //'smilepay_palmboxc2cup_mobile_number' => $smilepaypalmboxc2cup_result['Mobile_number'],
                         )
                );

        return $block;
        
  }
  public function checkoutShippingConfig()
  {
      return array(
                    $this->serivce_config[self::METHOD_NORMAL]['field_method_id']=>array(
                                            'emap_url'=>$this->getEMapUrl( self::METHOD_NORMAL)
                                        ),
                  
                );
  }
 
  public function convertCVSTypeToMethodid($csvtype)
  {
      return  isset($this->serivce_config[$csvtype]['field_method_id']) ? $this->serivce_config[$csvtype]['field_method_id']: '';
  }

   /*public function getPay_subzg($service_id)
  {
      return isset($this->serivce_config[$service_id]['pay_subzg']) ? $this->serivce_config[$service_id]['pay_subzg']:'';
  }
  public function getCSVTypeName($service_id)
  {
      return isset($this->serivce_config[$service_id]['csvTypeName'])? $this->serivce_config[$service_id]['csvTypeName'] :'';  
  }*/

}
?>