<?php
namespace Smilepay\Smilepaypalmboxc2cup\Observer;

use Magento\Framework\Event\ObserverInterface;
    use Magento\Framework\DataObject;
use Magento\Payment\Model\InfoInterface;
use Magento\Payment\Model\MethodInterface;
use Magento\Payment\Observer\AbstractDataAssignObserver;
use Magento\Sales\Model\Order\Invoice;
use Magento\Sales\Model\Order\Payment;
use Magento\Quote\Api\Data\PaymentMethodInterface;


class SaveOrderCSVData  implements ObserverInterface
{
    protected $_storeManager;
    protected $_orderFactory;
    protected $_smilepaypalmboxc2cup_session;
    protected $_smilepaypalmboxc2cup_helper_data;
    protected $_smilepaypalmboxc2cup_shippingmethod;

    protected $_context;
    public function __construct(
        \Magento\Framework\App\Action\Context $context,
        \Magento\Sales\Model\Order $orderFactory,
        \Smilepay\Smilepaypalmboxc2cup\Model\Session $smilepaypalmboxc2cup_session,
        \Magento\Store\Model\StoreManagerInterface $storeManager,
        \Smilepay\Smilepaypalmboxc2cup\Helper\Data   $smilepaypalmboxc2cup_helper_data,
        \Smilepay\Smilepaypalmboxc2cup\Model\Shippingmethod   $smilepaypalmboxc2cup_shippingmethod
        
        )
    {
        $this->_storeManager = $storeManager;
        $this->_orderFactory = $orderFactory;
        $this->_smilepaypalmboxc2cup_session = $smilepaypalmboxc2cup_session;
        $this->_smilepaypalmboxc2cup_helper_data=$smilepaypalmboxc2cup_helper_data;
        $this->_smilepaypalmboxc2cup_shippingmethod =  $smilepaypalmboxc2cup_shippingmethod;
        $this->_context =$context;
    }

  //generate order info to checkout success
  public function execute(\Magento\Framework\Event\Observer $observer)
  {
      $event = $observer->getEvent();
    
      $order = $event->getOrder();
      $order_id = $order->getId();

      //if(!isset($order_id) || empty($order_id))
        //  return;
      //$order =$this->_orderFactory;
      //$order->load($order_id);
      $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
      $quote = $objectManager->create('\Magento\Quote\Model\Quote');
      $quote->load($order->getQuoteId());
      if(empty($order->getQuoteId()))
         return;
      $shippingmethod = $quote->getShippingAddress()->getShippingMethod();
      if(strpos(trim($shippingmethod), 'smilepaypalmboxc2cup_')===0 )
      {
          $smilepaypalmboxc2cup_model = $this->_smilepaypalmboxc2cup_shippingmethod;
          
          if($smilepaypalmboxc2cup_model->isEmapSelected())
          {
            
            $cvsstoredata =  $smilepaypalmboxc2cup_model->getpalmboxc2cupStoreData();
            $data['cvsstoredata'] = $cvsstoredata['Storeid'] .'/' . $cvsstoredata['Storename'] .'/' . $cvsstoredata['Storeaddress'];
            
            $smilepaypalmboxc2cup_model->savepalmboxc2cupData(  $order->getIncrementId(),  $data);
            //add note
            $comment = sprintf(__('smilepay_palmboxc2cup_save_success'), $cvsstoredata['Storeid'] , $cvsstoredata['Storename'] , $cvsstoredata['Storeaddress'] );
            $history = $order->addStatusHistoryComment($comment,false);
            $history->setIsCustomerNotified(true);
            $history->setIsVisibleOnFront(1);
            $order->save();
          }
     
      }
    
  }
}


?>