define(
    [
         'Magento_Checkout/js/model/quote',
    ],
    function (quote) {
        "use strict";
        return {
            
            isSmilepaypalmboxc2cupSelected: function () {
                if(quote.shippingMethod() )
                {
                    var selected_shipping_code =  quote.shippingMethod().carrier_code + '_' + quote.shippingMethod().method_code;
                      
                    if(selected_shipping_code.indexOf('smilepaypalmboxc2cup_')==0)
                        return true;
                    else
                        return false;
                }
                       
            },
            getSmilepaypalmboxc2cupBlock: function(){
                return window.checkoutConfig.shipping.block['smilepaypalmboxc2cup'];
            },
            getSmilepaypalmboxc2cupStoreInfoBlock: function(){
                return window.checkoutConfig.shipping.block['smilepaypalmboxc2cup_storeinfo'];
            },
            getSmilepaypalmboxc2cupStoreData: function(){
            
                return { "StoreId":window.checkoutConfig.shipping.data.smilepaypalmboxc2cup.storeId,
                   "StoreName": window.checkoutConfig.shipping.data.smilepaypalmboxc2cup.storeName,
                   "StoreAddr": window.checkoutConfig.shipping.data.smilepaypalmboxc2cup.storeAddr,
                    };
            },

            getSmilepaypalmboxc2cupStoreSelected: function(){ 
                return window.checkoutConfig.shipping.data.smilepaypalmboxc2cup.selected;        
            },

            getCurrentEmapUrl: function()
            {
                var method_code=quote.shippingMethod().method_code;
                return  window.checkoutConfig.shipping.data.smilepaypalmboxc2cup[method_code]['emap_url'];
            },
            

            isSmilepaypalmboxc2cupCustomerNameValid: function()
            {
                var shippingAddr= quote.shippingAddress();
              
                var name = shippingAddr.lastname + shippingAddr.firstname;
                var maxlen = 10;
                if(!name.match(/^[a-zA-Z0-9\s]+$/))
                {
                    maxlen = 5;
                }
                if(name.length > maxlen)
                {
                    return false;
                }else
                    return true;
                
            },
            isSmilepaypalmboxc2cupCustomerPhoneValid: function()
            {
                var shippingAddr= quote.shippingAddress();
                var re=/^[0][9][0-9]{8,8}$/;
                var phone = shippingAddr.telephone;
                
                if(!phone.match(re))
                {
                   return false;
                }
              
                return true;
            }

         };
    }
);
